/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/* TAU RTOS integration for Nucleus PLUS */

#include <nucleus.h>

#ifndef USER_CFG_SYSTEM_MEMEORY
  #define USER_CFG_SYSTEM_MEMEORY 16000
#endif
#ifndef USER_CFG_MIN_ALLOCATION
  #define USER_CFG_MIN_ALLOCATION 64
#endif
#ifndef USER_CFG_MANAGER_STACK_SIZE
  #define USER_CFG_MANAGER_STACK_SIZE 512
#endif
#ifndef USER_CFG_TICKS_PER_SEC
  #error "USER_CFG_TICKS_PER_SEC not defined"
#endif
#ifndef USER_CFG_NS_PER_TICK
  #error "USER_CFG_NS_PER_TICK not defined"
#endif
#define XMAIN_NAME UML_main

typedef struct {
  NU_SEMAPHORE SignalQueueMutex;
  NU_SEMAPHORE SignalQueueCond;
  NU_TASK      Task;
} xThreadVars;

#define DEFAULT_STACKSIZE      800
#define DEFAULT_PRIO           128
#define DEFAULT_USER1            0
#define DEFAULT_USER2            0

extern NU_SEMAPHORE xFreeSignalMutex;
extern NU_SEMAPHORE xFreeTimerMutex;
extern NU_SEMAPHORE xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  extern NU_SEMAPHORE xMemoryMutex;
#endif
extern NU_SEMAPHORE xInitSem;
#if !defined(USER_CFG_USE_xInEnv) && !defined(XENV)
  extern NU_SEMAPHORE xMainThreadSem;
#endif

extern void xThreadInit (void);
extern void xThreadInitOneThread (struct _xSystemData *);
extern void xThreadStartThread (struct _xSystemData *, unsigned int, unsigned int,
                                unsigned int, unsigned int);
#if defined(THREADED) || defined(CFG_USED_DYNAMIC_THREADS)
  extern void xThreadStopThread (struct _xSystemData *);
#endif
extern void xThreadGo (void);
extern void xThreadLock (NU_SEMAPHORE *);
extern void xThreadUnlock (NU_SEMAPHORE *);
extern void xThreadWaitUnlock (struct _xSystemData *);
extern void xThreadSignalUnlock (struct _xSystemData *);
extern SDL_Time xNow (void);
#define xInitSystime()

