/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/* TAU RTOS integration for OSE */

#include "rtapidef.sig"
#include "time.h"
#include "rtc.h"

#define USER_CFG_USE_USER_MEMFUNC
#define XUSER_ALLOC_FUNC
#define XUSER_FREE_FUNC
/* xAlloc and xFree functions added in rtapidef.c */

union SIGNAL {
  SIGSELECT sig_no;
  struct uml_startup uml_startup;
  struct uml_wakeup uml_wakeup;
};
static const SIGSELECT any_sig[] = {0};

typedef struct {
  SEMAPHORE    *SignalQueueMutex;
  PROCESS       ThreadId;
} xThreadVars;

#define DEFAULT_STACKSIZE     1024
#define DEFAULT_PRIO            16
#define DEFAULT_USER1            0
#define DEFAULT_USER2            0

extern SEMAPHORE *xFreeSignalMutex;
extern SEMAPHORE *xFreeTimerMutex;
extern SEMAPHORE *xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  extern SEMAPHORE *xMemoryMutex;
#endif
extern SEMAPHORE *xInitSem;
#if (!defined(USER_CFG_USE_xInEnv)) && (!defined(XENV))
  extern SEMAPHORE *xMainThreadSem;
#endif

extern void xThreadInit (void);
extern void xThreadInitOneThread (struct _xSystemData *);
extern void xThreadStartThread (struct _xSystemData *, unsigned int, unsigned int,
                                unsigned int, unsigned int);
#if defined(THREADED) || defined(CFG_USED_DYNAMIC_THREADS)
  extern void xThreadStopThread (struct _xSystemData *);
#endif
extern void xThreadGo (void);
extern void xThreadLock (SEMAPHORE **);
extern void xThreadUnlock (SEMAPHORE **);
extern void xThreadWaitUnlock (struct _xSystemData *);
extern void xThreadSignalUnlock (struct _xSystemData *);
extern SDL_Time xNow (void);
#define xInitSystime()

