/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/* TAU RTOS integration for microC/OS-II */


#include "includes.h"



typedef struct {
  OS_EVENT *   SignalQueueMutex;
  OS_EVENT *   SignalQueueCond;
  INT16U       ThreadId;
  OS_STK   *ptos;		/* top of stack */
  OS_STK   *pbos;		/* bottom of stack */
} xThreadVars;

#define DEFAULT_STACKSIZE      800              /* must be an even integer */
#define DEFAULT_PRIO           128
#define DEFAULT_USER1            0
#define DEFAULT_USER2            0
#define WAIT_FOREVER		 0
#define NO_WAIT			 1 /* wait max one tick */

extern OS_EVENT *xFreeSignalMutex;
extern OS_EVENT *xFreeTimerMutex;
extern OS_EVENT *xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  extern OS_EVENT *xMemoryMutex;
#endif
extern OS_EVENT *xInitSem;
#if !defined(USER_CFG_USE_xInEnv) && !defined(XENV)
  extern OS_EVENT *xMainThreadSem;
#endif

extern void xThreadInit (void);
extern void xThreadInitOneThread (struct _xSystemData *);
extern void xThreadStartThread (struct _xSystemData *, unsigned int, unsigned int,
                                unsigned int, unsigned int);
#if defined(THREADED) || defined(CFG_USED_DYNAMIC_THREADS)
  extern void xThreadStopThread (struct _xSystemData *);
#endif
extern void xThreadGo (void);
extern void xThreadLock (OS_EVENT *);
extern void xThreadUnlock (OS_EVENT *);
extern void xThreadWaitUnlock (struct _xSystemData *);
extern void xThreadSignalUnlock (struct _xSystemData *);
extern SDL_Time xNow (void);
#define xInitSystime()

