/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************
 
  External task for the example Simple.
  VxWorks tight integration version.
 
*******************************************************************/

#include "scttypes.h"
#include "simple.hs"
#include "simple.ifc"

/****+***************************************************************
     Simple example: MyExtTask
********************************************************************/
void MyExtTask(void)
{
  xSignalHeader yOutputSignalPtr, yInputSignalPtr;
  int i, Err;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
  SDL_PId         MyOwnPId;
  xPrsIdRec       NameNodeStruct;
  xEPrsRec        MyEPrsStruct;
  MSG_Q_ID        MyPId;
#else
  SDL_PId MyPId;
#endif

  /* creation of messageQueue */ 
  MyPId = msgQCreate(MAX_INPUTPORT_LENGTH , VXMAXMSGLENGTH, \
                                   MSG_Q_FIFO);

  /*allocation of signal go */
for(i=1;i<=2;i++) {
  yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec) + sizeof(yPDef_go));
  yOutputSignalPtr->SignalCode = go;

  /*Sender is assigned MyExtTask=(MyPid) */
  if(i==1) {
    /*Integer parameter is assigned 1 (=startinstance1) */
    ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance1;}
  else {
   /*Integer parameter is assigned 2 (=startinstance2) */
    ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance2;}

#ifdef X_ONE_TASK_PER_INSTANCE_SET
  /* assignment of own id */
  MyOwnPId=&MyEPrsStruct;
  MyOwnPId->NameNode=&NameNodeStruct;
  MyOwnPId->NameNode->PROCID=(unsigned long *)MyPId;
  yOutputSignalPtr->Sender=MyOwnPId;

  /* assignment of receiving proc instance */
  yOutputSignalPtr->Receiver = pr1[i];
  Err = msgQSend((MSG_Q_ID)pr1[i]->NameNode->PROCID, (char*)yOutputSignalPtr,
                 sizeof(xSignalHeaderRec) + sizeof(yPDef_go),
                 0,0);
#else
  yOutputSignalPtr->Sender = MyPId;
  Err = msgQSend(pr1[i], (char*)yOutputSignalPtr,
                 sizeof(xSignalHeaderRec) + sizeof(yPDef_go),
                 0,0);
#endif
}

for(i=1;i<=2;i++) {
  /*allocation of input signal */
  yInputSignalPtr = xAlloc(VXMAXMSGLENGTH);

  /*waiting for signal ok */
  Err = msgQReceive(MyPId,(char*)yInputSignalPtr,VXMAXMSGLENGTH, WAIT_FOREVER);
  if(yInputSignalPtr->SignalCode == ok)
   printf("Ok received in MyExtTask with paramer = %lu\n",
            ((yPDef_ok*)(yInputSignalPtr+1))->Param1); 
}
  /*task MyExtTask is Suspended */
  taskSuspend(0);
}
