/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  External task for the example Simple.
  Win32 tight integration version.

*******************************************************************/

#include "scttypes.h"
#include "simple.hs"
#include "simple.ifc"

/****+***************************************************************
     Simple example: MyExtTask
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET

extern void MyExtTask XPP(( void ))
{
  xSignalHeader yInputSignalPtr, yOutputSignalPtr;
  unsigned long RetCode;
  MSG win32Mess;
  unsigned long MyThreadId;
  xPrsIdNode MyPrsId;
  SDL_PId MyPId;
  int i;

  MyThreadId = (unsigned long)GetCurrentThreadId();
  MyPrsId = xAlloc(sizeof(xPrsIdRec));
  MyPId = xAlloc(sizeof(xEPrsRec));
  MyPId->NameNode = MyPrsId;
  MyPId->NameNode->PROCID = (unsigned long *)MyThreadId;

#ifdef XMSC_EDITOR
  RTOSMSCPRINT_START
      sprintf(msce_buf, "%lu %s %s %s", MyPId, ": instancehead process ", "MyExtTask", ";");
  RTOSMSCPRINT_STOP
#else
    /*  XOS_TRACE_STATIC_CREATE(MyPId, "MyExtTask")
  XMSC_TRACE_STATIC_CREATE(MyPId, "MyExtTask") */
#endif

for(i=1;i<=2;i++) {
  yOutputSignalPtr = (xSignalHeader)xAlloc (sizeof (xSignalHeaderRec) + sizeof(yPDef_go));
  yOutputSignalPtr->SignalCode = go;
  yOutputSignalPtr->Receiver = pr1[i];
  yOutputSignalPtr->Sender = MyPId;
  yOutputSignalPtr->SigP = yOutputSignalPtr + 1;
  win32Mess.wParam = (WPARAM)yOutputSignalPtr;
  if (i==1)
     ((yPDef_go*)(yOutputSignalPtr->SigP))->Param1 = startinstance1;
  else
     ((yPDef_go*)(yOutputSignalPtr->SigP))->Param1 = startinstance2;
  RetCode = PeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_NOREMOVE );
  XOS_ERROR("MyExtTask", "PeekMessage", RetCode)
  win32Mess.lParam = (DWORD)(pr1[i]->NameNode->PROCID);

#ifdef XMSC_TRACE
  SignalId = SignalId + 1;
  yOutputSignalPtr->SignalId = SignalId;
  yOutputSignalPtr->IsTimer = 0;

#ifdef XMSC_EDITOR
  RTOSMSCPRINT_START
  sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
           yOutputSignalPtr->Sender, ": out ", "go", ",", SignalId, " to ", pr1[i], ";");
  RTOSMSCPRINT_STOP

#else  /* XMSC_EDITOR */

  XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", yOutputSignalPtr->Sender, "go", SignalId, pr1[i]))

#endif  /* XMSC_EDITOR */
#endif  /* XMSC_TRACE */

  RetCode = 0;
  while (RetCode == 0) { 
  RetCode = PostThreadMessage( win32Mess.lParam, WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam);  
  }
  XOS_ERROR ("MyExtTask", "PostThreadMessage", RetCode)
    }

for(i=1;i<=2;i++) {
  RetCode = GetMessage ( &win32Mess, (HWND) NULL, 0, 0 );
  XOS_ERROR("MyExtTask", "GetMessage", RetCode)
  yInputSignalPtr = (xSignalHeader) win32Mess.wParam;
  if(yInputSignalPtr->SignalCode == ok) {
#ifdef XMSC_TRACE

#ifdef XMSC_EDITOR
  RTOSMSCPRINT_START
  sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
          yInputSignalPtr->Receiver, ": in ", "ok", ",", yInputSignalPtr->SignalId, " from ", yInputSignalPtr->Sender, ";");
  RTOSMSCPRINT_STOP

#else  /* XMSC_EDITOR */

  XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", yInputSignalPtr->Receiver, "ok", yInputSignalPtr->SignalId, \
         yInputSignalPtr->Sender))
#endif  /* XMSC_EDITOR */

#else  /* XMSC_TRACE */

    printf("Ok received in MyExtTask with parameter = %lu\n",
      ((yPDef_ok*)(yInputSignalPtr+1))->Param1); 

#endif  /* XMSC_TRACE */

  }
  xFree((void**)(&yInputSignalPtr));
}
  SuspendThread(GetCurrentThread());
}

#else

extern void MyExtTask XPP(( void ))
{
  xSignalHeader yInputSignalPtr, yOutputSignalPtr;
  unsigned long RetCode;
  MSG win32Mess;
  unsigned long MyThreadId;
  int i;

  MyThreadId = (WPARAM)GetCurrentThreadId();
#ifdef XMSC_EDITOR
  RTOSMSCPRINT_START
      sprintf(msce_buf, "%lu %s %s %s", MyThreadId, ": instancehead process ", "MyExtTask", ";");
  RTOSMSCPRINT_STOP
#else
    /*  XOS_TRACE_STATIC_CREATE(MyThreadId, "MyExtTask")
  XMSC_TRACE_STATIC_CREATE(MyThreadId, "MyExtTask")*/
#endif

for(i=1;i<=2;i++) {
  yOutputSignalPtr = (xSignalHeader)xAlloc (sizeof (xSignalHeaderRec) + sizeof(yPDef_go));
  yOutputSignalPtr->SignalCode = go;
  yOutputSignalPtr->Sender = MyThreadId;
  yOutputSignalPtr->SigP = yOutputSignalPtr + 1;
  win32Mess.wParam = (WPARAM)yOutputSignalPtr;
  if(i==1)
    ((yPDef_go*)(yOutputSignalPtr->SigP))->Param1 = startinstance1;
  else
    ((yPDef_go*)(yOutputSignalPtr->SigP))->Param1 = startinstance2;
  RetCode = PeekMessage(&win32Mess, (HWND) NULL, 0, 0, PM_NOREMOVE );
  XOS_ERROR("MyExtTask", "PeekMessage", RetCode)

#ifdef XMSC_TRACE
  RTOSMSCPRINT_START
  SignalId = SignalId + 1;
  yOutputSignalPtr->SignalId = SignalId;
  yOutputSignalPtr->IsTimer = 0;

#ifdef XMSC_EDITOR
  sprintf(msce_buf, "%lu %s %s %s %d %s %lu %s", \
           MyThreadId, ": out ", "go", ",", SignalId, " to ", pr1[i], ";");
  RTOSMSCPRINT_STOP

#else
  XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", MyThreadId, "go", SignalId, pr1[i]))
  RTOSMSCPRINT_STOP

#endif  /* XMSC_EDITOR */

#endif  /* XMSC_TRACE */

  RetCode = 0;
  while (RetCode == 0) { 
  RetCode = PostThreadMessage((DWORD)/*xFindReceiver (go ,xEnvPrs ,0)*/pr1[i],WM_SDL_SIGNAL, win32Mess.wParam, win32Mess.lParam);  
  }
  XOS_ERROR ("MyExtTask", "PostThreadMessage", RetCode)
}

for(i=1;i<=2;i++) {
  RetCode = GetMessage ( &win32Mess, (HWND) NULL, 0, 0 );
  XOS_ERROR("MyExtTask", "GetMessage", RetCode)
  yInputSignalPtr = (xSignalHeader) win32Mess.wParam;
  if(yInputSignalPtr->SignalCode == ok) {

#ifdef XMSC_TRACE
#ifdef XMSC_EDITOR
  RTOSMSCPRINT_START
  sprintf(msce_buf, "%lu %s %s %s %d %s %ld %s", \
          MyThreadId, ": in ", "ok", ",", yInputSignalPtr->SignalId, " from ", yInputSignalPtr->Sender, ";");
  RTOSMSCPRINT_STOP

#else
  XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", MyThreadId, "ok", yInputSignalPtr->SignalId, \
         yInputSignalPtr->Sender))
#endif  /* XMSC_EDITOR */
 
#else
    printf("Ok received in MyExtTask with parameter = %lu\n",
      ((yPDef_ok*)(yInputSignalPtr+1))->Param1);
#endif
  }
  xFree((void**)(&yInputSignalPtr));
}
  SuspendThread(GetCurrentThread());
}

#endif
	/* X_ONE_TASK_PER_INSTANCE_SET */
