/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************
 
  External task for the example Simple.
  Nucleus tight integration version.
 
*******************************************************************/

#include "scttypes.h"
#include "simple.hs"
#include "simple.ifc"

/****+***************************************************************
     Simple example: MyExtTask
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET

void MyExtTask(UNSIGNED argc, VOID *argv)
{
  xSignalHeader yOutputSignalPtr, yInputSignalPtr;
  int  	        i;
  SDL_PId 	MyOwnPId;
  xPrsIdRec	NameNodeStruct;
  xEPrsRec      MyEPrsStruct;
  STATUS        Err;
  SDL_PId       Self = argv;
  
  XMSC_TRACE_STATIC_CREATE( &MyEPrsStruct, "MyExtTask");

for(i=1;i<=2;i++) {
  yOutputSignalPtr = (xSignalHeader)xAlloc(sizeof(xSignalHeaderRec) + sizeof(yPDef_go));
  yOutputSignalPtr->SignalCode = go;

  MyOwnPId=&MyEPrsStruct;
  MyOwnPId->NameNode=&NameNodeStruct;
  MyOwnPId->NameNode->PROCID=(NU_QUEUE *)Self;
  yOutputSignalPtr->Receiver = pr1[i];
  yOutputSignalPtr->Sender = MyOwnPId;
 
  if(i==1)
    ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance1;
  else
    ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance2;
  Err = NU_Send_To_Queue((NU_QUEUE *)pr1[i]->NameNode->PROCID, &yOutputSignalPtr, 1, NU_SUSPEND);
  XOS_ERROR("MyExtTask", "NU_Send_To_Queue", Err)
#ifdef XMSC_TRACE  
  XMSC_FPRINT(("%lu: out %s,%d to %lu;\n", MyOwnPId, "go", SignalId, pr1[i]))
  RTOSMSCPRINT_STOP
#endif
    }

  /*waiting for signal ok */
for(i=1;i<=2;i++) {
  while( (Err = NU_Receive_From_Queue((NU_QUEUE *)Self, &yInputSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT)
	  XERROR_RECEIVED_WITH_TIMEOUT("MyExtTask")
  XOS_ERROR("MyExtTask", "NU_Receive_From_Queue", Err)

#ifdef XMSC_TRACE
  if(yInputSignalPtr->SignalCode == ok){
     XMSC_FPRINT(("%lu: in %s,%d from %lu;\n", MyOwnPId, "ok", yInputSignalPtr->SignalId,yInputSignalPtr->Sender))
     RTOSMSCPRINT_STOP
  }
#else
  if(yInputSignalPtr->SignalCode == ok)
    printf("Ok received in MyExtTask with parameter = %lu\r\r\n",
            ((yPDef_ok*)(yInputSignalPtr+1))->Param1); 
#endif 
  }
  Err = NU_Suspend_Task(NU_Current_Task_Pointer());
  XOS_ERROR("MyExtTask", "NU_Suspend_Task", Err)
}

#else

void MyExtTask(UNSIGNED argc, VOID *argv)
{
  xSignalHeader yOutputSignalPtr, yInputSignalPtr;
  int i;
  STATUS Err;
  SDL_PId Self = argv;

  /*allocation of signal go */  
for(i=1;i<=2;i++) {
  yOutputSignalPtr = xAlloc(sizeof(xSignalHeaderRec) + sizeof(yPDef_go));
  yOutputSignalPtr->SignalCode = go;

  /*Sender is assigned MyExtTask=(MyPid) */
  yOutputSignalPtr->Sender = (SDL_PId)Self;

  /*Integer parameter is assigned */
  if (i==1)
     ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance1;
  else
     ((yPDef_go*)(yOutputSignalPtr+1))->Param1 = startinstance2;
  Err = NU_Send_To_Queue(pr1[i], &yOutputSignalPtr, 1, NU_SUSPEND);
  XOS_ERROR("MyExtTask", "NU_Send_To_Queue", Err)
#ifdef XMSC_TRACE  
  XMSC_FPRINT(("0x%08x: out %s,%d to 0x%08x;\n", Self, "go", SignalId, pr1[i]))
  RTOSMSCPRINT_STOP
#endif  
    }

  /*waiting for signal ok */
for(;;) {
  while( (Err = NU_Receive_From_Queue(Self, &yInputSignalPtr, 1, &received_size, NU_SUSPEND)) == NU_TIMEOUT)
	  XERROR_RECEIVED_WITH_TIMEOUT("MyExtTask")
  XOS_ERROR("MyExtTask", "NU_Receive_From_Queue", Err)

#ifdef XMSC_TRACE
  if(yInputSignalPtr->SignalCode == ok){
     XMSC_FPRINT(("0x%08x: in %s,%d from 0x%08x;\n", Self, "ok", yInputSignalPtr->SignalId,yInputSignalPtr->Sender))
     RTOSMSCPRINT_STOP
  }
#else
  if(yInputSignalPtr->SignalCode == ok)
    printf("Ok received in MyExtTask with parameter = %lu\r\r\n",
            ((yPDef_ok*)(yInputSignalPtr+1))->Param1); 
#endif        
  xFree((void **)&yInputSignalPtr);
}
  Err = NU_Suspend_Task(NU_Current_Task_Pointer());
  XOS_ERROR("MyExtTask", "NU_Suspend_Task", Err)
}

#endif	/* X_ONE_TASK_PER_INSTANCE_SET */ 

















