/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  OS dependent C-functions

  To be used with Cadvanced SDL to C Compiler 4.4
  
*******************************************************************/

/****+***************************************************************
00   Include Files
********************************************************************/
#include "scttypes.h"

/****+***************************************************************
00   OS routines
********************************************************************/

/*---+---------------------------------------------------------------
     SDL_Clock
-------------------------------------------------------------------*/
extern SDL_Time SDL_Clock  XPP(( void )) 
{
  SDL_Time tmp;


  tmp  = RTOSSDLNOW2;

  return tmp;
}
       /* XCLOCK */
/*---+---------------------------------------------------------------
     mem alloc trace
-------------------------------------------------------------------*/
#if defined(XMEMTRACE)
  long int xmemtrace = 0;
  long int xtotmemtrace = 0;
  char *xmemtracepbuf[100];
#elif defined(XMEMORY_USAGE_MEASUREMENT)
  long int xCurrentMemoryUsage = 0;
  long int xMaxMemoryUsage = 0;
#endif
/*---+---------------------------------------------------------------
     xAlloc
-------------------------------------------------------------------*/
int Counter = 0;

extern void * xAlloc( xptrint  Size ) 

{
#if defined(XMEMTRACE)
  int * Tmp;
  void * Rtn;
  xtotmemtrace = xtotmemtrace + Size;
  sprintf((char *)xmemtracepbuf,
    "\n+Tot.mem = %d\n",xtotmemtrace );
  printf("%s",xmemtracepbuf);
#ifdef WIN32_INTEGRATION
  Tmp = (int *) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (DWORD) Size+sizeof(int));
#else
  Tmp = (int *) calloc((unsigned)1, (unsigned)Size+sizeof(int));
#endif
  Tmp[0] = Size;
  Rtn=(void*)(Tmp+1);
  return Rtn;
#elif defined(XMEMORY_USAGE_MEASUREMENT)
  int * Tmp;
  void * Rtn;
  xCurrentMemoryUsage = xCurrentMemoryUsage + Size;
  if(xCurrentMemoryUsage > xMaxMemoryUsage)
    xMaxMemoryUsage = xCurrentMemoryUsage;
#ifdef WIN32_TIGHTINTEGRATION
  Tmp = (int *) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (DWORD) Size+sizeof(int));
#else
  Tmp = (int *) calloc((unsigned)1, (unsigned)Size+sizeof(int));
#endif
  Tmp[0] = Size;
  Rtn=(void*)(Tmp+1);
  return Rtn;
#elif defined(XMEMCOUNTER)
  Counter ++;
  printf ("A:Memcounter is now %d\n", Counter);
  RTOSXALLOC
#else
  RTOSXALLOC
#endif
}

/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/

extern void xFree( void * *  P ) 

{
#if defined(XMEMTRACE)
  int * Tmp;
  if(*P!=0) {
    Tmp=(int*)*P-1;
    xtotmemtrace = xtotmemtrace -*Tmp;
    sprintf((char *)xmemtracepbuf,
      "\n-Tot.mem = %d\n", xtotmemtrace );
    printf("%s",xmemtracepbuf);
    *P=(void*)Tmp;
  }
#elif defined(XMEMORY_USAGE_MEASUREMENT)
  int * Tmp;
  if(*P!=0) 
  {
    Tmp=(int*)*P-1;
    xCurrentMemoryUsage = xCurrentMemoryUsage -*Tmp;
    *P=(void*)Tmp;
  }

#elif defined(XMEMCOUNTER)
  Counter --;
  printf ("R:Memcounter is now %d\n", Counter);
#endif
RTOSXFREE
}

#ifdef XOPTSIGNALALLOC
#ifdef VXWORKS_INTEGRATION
#define MAXSIGNALSIZE VXMAXMSGLENGTH
#endif
#ifdef CHORUS_INTEGRATION
#define MAXSIGNALSIZE  MAXSIGNALSIZECHORUS
#endif /* CHORUS_INTEGRATION */

xSignalNode xAvailSignalLists[MAXSIGNALSIZE+1];
xSignalNode xAvailTimer;

/*---+---------------------------------------------------------------
     xGetSignal
-------------------------------------------------------------------*/

extern xSignalNode xGetSignal(
  xSignalIdNode  SType,
  SDL_PId   Receiver,
  SDL_PId   Sender )

{
  xSignalNode Result;
  int SignalSize;

  if (xAvailSignalLists[SType->VarSize] != (xSignalNode)0) {
     Result = xAvailSignalLists[SType->VarSize];
     xAvailSignalLists[SType->VarSize] = Result->Suc;
    } else {
      Result = (xSignalNode)xAlloc((xptrint)SType->VarSize);
    }
  Result->Suc = (xSignalNode)0;
  Result->Pre = (xSignalNode)0;
  Result->Sender = Sender;
/*
  Result->Receiver = Receiver;
*/
  Result->NameNode = SType;
  return Result;
}
/*---+---------------------------------------------------------------
     xReleaseSignal
-------------------------------------------------------------------*/

extern void xReleaseSignal(
  xSignalNode  *S )

{
  int SignalSize;
  if (*S != (xSignalNode)0) {
#ifdef VXWORKS_INTEGRATION
    if((*S)->MaxSize) {
      (*S)->Suc = xAvailSignalLists[MAXSIGNALSIZE];
      xAvailSignalLists[VXMAXMSGLENGTH] = *S;
    }
    else {
#endif
      (*S)->Suc = xAvailSignalLists[(*S)->NameNode->VarSize];
      xAvailSignalLists[(*S)->NameNode->VarSize] = *S;
#ifdef VXWORKS_INTEGRATION
    }
#endif
  }
  *S = (xSignalNode)0;
}

#endif  /* XOPTSIGNALALLOC */

/*********************************************************************
	Free function for discarded signals
*********************************************************************/
#ifdef XFREESIGNALFUNCS

xFreeFuncListPtr xFreeFuncStructPtr;
xFreeFuncListPtr xHeadFreeFuncStructPtr;

void RegSignalFreeFunc(int SignalCode, void (* yFree_Sig)(void * SVarP) )
{
  xFreeFuncListPtr tmp;
  static int FirstTime = 0;

  tmp = xAlloc(sizeof (xFreeFuncListRec));
  tmp->SignalCode = SignalCode;
  tmp->xFree_Sig = yFree_Sig;
  tmp->Next = NULL;
  if ( FirstTime == 0 ) {
    xFreeFuncStructPtr = tmp;
    xHeadFreeFuncStructPtr = xFreeFuncStructPtr;
    FirstTime++;
  }
  else {
  xFreeFuncStructPtr->Next = tmp;
  xFreeFuncStructPtr = xFreeFuncStructPtr->Next;    
  }
}

void CallSignalFreeFunc( int SignalCode, void *SVarP )
{
  xFreeFuncListPtr ptr;

  ptr = xHeadFreeFuncStructPtr;
  while (ptr != NULL) {
    if (ptr->SignalCode == SignalCode) {
      (*ptr->xFree_Sig)(SVarP);
      break;
    }
    ptr = ptr->Next;
  }   
}

#endif
