/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-functions for RTOS-integrations

  To be used with Cadvanced SDL to C Compiler 4.4 
  
*******************************************************************/

#ifndef XTORNADOINT
#include <stdarg.h>
#endif
#include "scttypes.h"

/*
#ifdef XOPTSIGNALALLOC
extern struct xSignalIdStruct TimerIdDummy;
#endif
*/

#define xSymbolTableRoot      (&xSymbolTableIdRec) /* 3.1 */

/*--------------- 3.1 UPDATE -----------------*/
#define xSymbolTableRoot      (&xSymbolTableIdRec) /* 3.1 */
XCONST struct xIdStruct xSymbolTableIdRec = 
     {xSystemEC  xSymbTLink((xIdNode)0, (xIdNode)0),
     (xIdNode)0 xIdNames("SymbolTableRoot")};      /* 3.1 */

static XPRSNODE yEnvA_env = (XPRSNODE)0;
static XPRSNODE yEnvB_env = (XPRSNODE)0;
XCONST struct xPrsIdStruct yEnvR_env = {xProcessEC xSymbTLink((xIdNode)0,
  (xIdNode)0), (xIdNode)&xSymbolTableIdRec xIdNames("env") XCOMMON_EXTRAS,
  0, 0 xService(0) xOptChan(yEnvO_env), 1 xNrInst(1) xNrInst(1), &yEnvB_env,
  (xptrint)sizeof(xPrsRec) xPrsPrioPar(xDefaultPrioProcess), &yEnvA_env
  xTrace(-1) xGRTrace(-1) xBreakB(0) xBreakB(-1) xBreakB(0) xMSCETrace(-1)
  xCoverage(0) xCoverage(0) xCoverage(0), 0, 0, (xPrsIdNode)0, (xPrdIdNode *)0,
  (xBlockIdNode)0 xBreakB("") XPRS_EXTRAS(env)};
#ifndef XNOSTARTUPIDNODE
static XCONST struct xSignalIdStruct ySigR_Env = {xStartUpSignalEC
  xSymbTLink((xIdNode)0, (xIdNode)0), (xIdNode)&xSymbolTableIdRec
  xIdNames("-") XCOMMON_EXTRAS, (xptrint)sizeof(XSIGNALHEADERTYPE), 0, 0
  xFreS(0) SIGCODE(STARTUPSIGNAL) xBreakB("") XSIG_EXTRAS};
#endif
/* 3.1 end */
/*-------------------------------------------- */

/* FOR TESTING PURPOSE */
int myrandom = 0;

RTOSGLOBAL_VAR

HOOK_GLOBAL_DECLARATIONS
/*
#ifdef XOS_TRACE
SDL_PId LastUsedPId;
#endif
*/

#ifdef XTORNADOINT
int SignalId = 0;
#endif

#ifdef XMSC_TRACE
int SignalId = 0;
#endif

XCONST struct xStateIdStruct xStartStateIdRec = {xStateEC
  xSymbTLink((xIdNode)0, (xIdNode)0), (xIdNode)0 xIdNames("start state"),
  START_STATE, 0, 0, 0, 0, (xbool)0 xCoverage(0), (xStateIdNode)0};

#ifdef XOS_TRACE
#ifdef X_ONE_TASK_PER_INSTANCE_SET
xEPrsNode LastUsedPId;
#else
SDL_PId LastUsedPId;
#endif
#endif

/****+***************************************************************
     SDL Save
********************************************************************/

/*---+---------------------------------------------------------------
     xSaveSignal
-------------------------------------------------------------------*/

extern void xSaveSignal (RTOSSAVEQ_TYPE SaveQ, RTOSSIGNAL_DEF  yInSignalPtr)

RTOSXSAVESIGNAL

/*---+---------------------------------------------------------------
     xDiscardSignal
-------------------------------------------------------------------*/

extern void xDiscardSignal (RTOSSAVEQ_TYPE *DiscardSignal)

{
  RTOSSAVEQ_TYPE Prev;

  Prev = (*DiscardSignal)->Pre;
  RTOSFREE_BUF_SIGP(&(*DiscardSignal)->SigP);
  (*DiscardSignal)->Pre->Suc = (*DiscardSignal)->Suc;
  (*DiscardSignal)->Suc->Pre = (*DiscardSignal)->Pre;
  /******free_buf(Discardsignal);******/
/*  RTOSFREE_BUF((RTOSSIGNAL_DEF*)&(*DiscardSignal));*/
  xFree((void **)&(*DiscardSignal));
  (*DiscardSignal) = Prev;
    /* Next Suc is to lead to signal after DiscardSignal */
}


/*---+---------------------------------------------------------------
     xKillSaveQ
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET

extern void xKillSaveQ (RTOSSAVEQ_TYPE  SaveQ, SDL_PId CurrentPId)

{
  RTOSSAVEQ_TYPE Temp1,Temp2;
  /*
       * Remove and release all signals in the save queue that is
         aimed for CurrentPID.
  */
  Temp1 = SaveQ->Suc;
  while (Temp1 != SaveQ) {
        Temp2 = Temp1->Suc;
        if ( xEq_SDL_PId(RTOSTEMP_RECEIVER, CurrentPId) ) {
          xDiscardSignal(&Temp1);
        }
        Temp1 = Temp2;
  }
}
#else

extern void xKillSaveQ (RTOSSAVEQ_TYPE  SaveQ)

{
  RTOSSAVEQ_TYPE Temp1, Temp2;

  Temp1 = SaveQ->Suc;
  while (Temp1 != SaveQ) {
    Temp2 = Temp1->Suc;
    RTOSFREE_BUF_SIGP(&(Temp1->SigP));
    RTOSFREE_BUF((RTOSSIGNAL_DEF*)&Temp1);
    Temp1 = Temp2;
  }
  xFree((void**)(RTOSSIGNAL_DEF*)&SaveQ);
}
#endif
/*---+---------------------------------------------------------------
     xContentsInstNode
-------------------------------------------------------------------*/
/* Given the IdNode for the currently executing unit (process,
   service, procedure), and the IdNode for a container type 
   (block type for example), this function returns the IdNode
   for the container instance. */


extern xIdNode xContentsInstNode (
  xIdNode  CurrentInst,
  xIdNode  TypeToFindInstOf )

{
  xIdNode TypeNode;
  TypeNode = CurrentInst;
  while (TypeNode != TypeToFindInstOf) {
    if (TypeNode->EC == xSystemTypeEC || TypeNode->EC == xSystemEC)
      TypeNode = (xIdNode)((xSystemIdNode)TypeNode)->Super;
    else if (TypeNode->EC == xBlockTypeEC || TypeNode->EC == xBlockEC)
      TypeNode = (xIdNode)((xBlockIdNode)TypeNode)->Super;
    else if (TypeNode->EC == xProcessTypeEC || TypeNode->EC == xProcessEC)
      TypeNode = (xIdNode)((xPrsIdNode)TypeNode)->Super;
#ifndef XNOUSEOFSERVICE
    else if (TypeNode->EC == xServiceTypeEC || TypeNode->EC == xServiceEC)
      TypeNode = (xIdNode)((xSrvIdNode)TypeNode)->Super;
#endif
    else if (TypeNode->EC == xProcedureEC)
      TypeNode = (xIdNode)((xPrdIdNode)TypeNode)->Super;
    else
      TypeNode = (xIdNode)0;
    if (TypeNode == (xIdNode)0) {
      CurrentInst = CurrentInst->Parent;
      TypeNode = CurrentInst;
    }
  }
  return CurrentInst;
}


/*---+---------------------------------------------------------------
     xPrsInst
-------------------------------------------------------------------*/
/* Given the IdNode for the currently executing process and the IdNode
   for a container type (block type for example), this function finds
   the container instance and returns the xPrsIdNode and index Index
   in the containers Contents array. */

xPrsIdNode xPrsInst(
  xIdNode  CurrentInst,
  xIdNode  TypeToFindInstOf,
  int      Index)
{
  xIdNode  ScopeInst;
  ScopeInst = xContentsInstNode(CurrentInst, TypeToFindInstOf);
  if (ScopeInst->EC == xSystemEC)
    return (xPrsIdNode)((xSystemIdNode)ScopeInst)->Contents[Index];
  return (xPrsIdNode)((xBlockIdNode)ScopeInst)->Contents[Index];
}



/*---+---------------------------------------------------------------
     xFindInputAction
-------------------------------------------------------------------*/

/* Given two identifier nodes representing a signal and a state, this
   function returns how the signal should be treated in the actual
   state (input, save, discard, not in signalset), taking possible
   enabling conditions into concideration. */


extern xInputAction xFindInputAction(
  XSIGTYPE     SignalId,
  xPrsNode     VarP)

{
  int           Pos;
  xbool         InProcess;
  xIdNode       PrsId;
  xStateIdNode  StateId;
  xInputAction  Result = xDiscard;

  /* In RPC wait state: xInput for pREPLY, xSave for everything else */
  if ( VarP->pREPLY_Waited_For != (XSIGTYPE)0 ) {
    if ( SignalId != VarP->pREPLY_Waited_For ) return xSave;
    VarP->pREPLY_Waited_For = (XSIGTYPE)0;
    if ( VarP->ActivePrd == (xPrdNode)0 )
      VarP->State = VarP->StateAfterRPC; 
    else
      VarP->ActivePrd->State = VarP->ActivePrd->StateAfterRPC; 
    return xInput;
  }

  if ( VarP->ActivePrd == (xPrdNode)0 ) {
    /* If start state then save all signals except start up signal. */
    if ( VarP->State == START_STATE ) return xSave;
    InProcess = (xbool)1;
    StateId = VarP->PrsNode->NameNode->StateList[VarP->State];
  } else {
    InProcess = (xbool)0;
    StateId = VarP->ActivePrd->NameNode->StateList[VarP->ActivePrd->State];
  }

  /* Locate the position of the signal in the signal set array for
     the actual process. Note that the last position in this array
     holds the value 0. */

  while (StateId != (xStateIdNode)0) {
    PrsId = StateId->Parent;

    Pos = 0;
    if (InProcess) {
      while ( ((xPrsIdNode)PrsId)->SignalSet[Pos] != (XSIGTYPE)0 &&
              ((xPrsIdNode)PrsId)->SignalSet[Pos] != SignalId )
        Pos++;
    } else {
      while ( ((xPrdIdNode)PrsId)->SignalSet[Pos] != (XSIGTYPE)0 &&
              ((xPrdIdNode)PrsId)->SignalSet[Pos] != SignalId )
        Pos++;
    }

    /* Use the computed position to find the signal handling in the
       signal handling array in the state identifier node. If this
       array position contains xEnablCond call the Enabling condition
       function to compute the result. The last position in this array,
       which coinside with the 0 value in the signal set array, holds
       the value xNotInSignalSet. */
    if ( (StateId->SignalHandlArray)[Pos] == xEnablCond )
      Result = (*StateId->EnablCond_Function)(SignalId, (void *)VarP);
    else
      Result = (StateId->SignalHandlArray)[Pos];
    if (Result != xDiscard) {
      /* If INPUT then save RestartPAD and RestartAddress in xPrsNode */
      if (Result == xInput) {
        if (VarP->ActivePrd == (xPrdNode)0) {
          VarP->RestartPAD =
            ((xPrsIdNode)PrsId)->PAD_Function;
          VarP->RestartAddress = (StateId->InputRef)[Pos];
        } else {
          VarP->ActivePrd->RestartPRD =
            ((xPrdIdNode)PrsId)->Assoc_Function;
          VarP->ActivePrd->RestartAddress = (StateId->InputRef)[Pos];
        }
      }
      return Result;
    }
    StateId = StateId->Super;
  }
  return Result;
}

#ifdef X_ONE_TASK_PER_INSTANCE_SET

/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

extern xbool xInputSignal (
  xPrsNode     *yVarP,
  xPrsInstanceSetVars *yInstanceSetVars,
  int           WhereToStart,
  SDL_PId       InputPortQ)

{
  RTOSXINPUTSIGNALVARS

  if (WhereToStart == 1) goto Label_New_Transition;
  if (WhereToStart == 2) goto Label_New_Transition_No_Free;
  if ( (*yVarP) == (xPrsNode)0 ||
       ( (*yVarP)->RestartAddress == 0 &&
         ( (*yVarP)->PrsNode == NIL ||
           (*yVarP)->RestartPAD == (*yVarP)->PrsNode->NameNode->PAD_Function
         )
       )
     )
    goto Label_Receive_Signal;
  return (xbool)0;

Label_New_Transition :   /*GLOB*/
  if (yInstanceSetVars->CurrentInSaveQ != yInstanceSetVars->SaveQ) {
    xDiscardSignal(&yInstanceSetVars->CurrentInSaveQ);
  }
  else
    RTOSFREE_BUF(&(yInstanceSetVars->yInSignalPtr));
Label_New_Transition_No_Free:  /*GLOB*/
  yInstanceSetVars->CurrentInSaveQ = yInstanceSetVars->SaveQ;
  if ((*yVarP)->RestartPAD != (*yVarP)->PrsNode->NameNode->PAD_Function) {
    if ((*yVarP)->ActivePrd == (xPrdNode)0) {
      (*yVarP)->RestartPAD = (*yVarP)->PrsNode->NameNode->PAD_Function;
      if ( (*yVarP)->pREPLY_Waited_For == (XSIGTYPE)0 )
	       return (xbool)1;
    }
  }
Label_Next_Saved :
  yInstanceSetVars->CurrentInSaveQ = yInstanceSetVars->CurrentInSaveQ->Suc;
  if (yInstanceSetVars->CurrentInSaveQ != yInstanceSetVars->SaveQ) {
    yInstanceSetVars->yInSignalPtr = RTOSCURRENTINSAVEQ;
    goto Label_Handle_Signal;
  }
Label_Receive_Signal :
  RTOSRECEIVE(yInstanceSetVars->yInSignalPtr,SDL_SELF,0, SDL_NULL)
Label_Handle_Signal :
  if (RTOSSTARTUPSIGNAL == STARTUPSIGNAL) {
    *yVarP = RTOSSTARTUPSIGNALVARP;
    (*yVarP)->RestartAddress = 0;
    (*yVarP)->PrsNode = 0;
    (*yVarP)->RestartPAD = RTOSSTARTUPSIGNALRESTARTPAD;
    (*yVarP)->ActivePrd = (xPrdNode)0;
    (*yVarP)->Offspring = SDL_NULL;
    (*yVarP)->PrsNode = RTOSSTARTUPSIGNALRECEIVER;
    (*yVarP)->Sender = SDL_NULL;
    (*yVarP)->Parent = RTOSSTARTUPSIGNALPARENT;
    (*yVarP)->State = START_STATE;
    (*yVarP)->pREPLY_Waited_For = (XSIGTYPE)0;
    (*yVarP)->StateAfterRPC = 0;
    RTOSXINPUTSIGNAL_SEMS
    return (xbool)0;
  }
  *yVarP = RTOSSTARTUPSIGNALVARP;
  switch (xFindInputAction(RTOSSTARTUPSIGNAL,
                           (xPrsNode)(*yVarP))) {
    case xNotInSignalSet :
    case xDiscard :
      /* discard signal */
      XOS_TRACE_DISCARDADDR
      if (yInstanceSetVars->CurrentInSaveQ != yInstanceSetVars->SaveQ) {
        RTOSCALLSIGNALFREEFUNCSAVEQ(yInstanceSetVars->CurrentInSaveQ);
/*        RTOSCALLSIGNALFREEFUNC(yInstanceSetVars->CurrentInSaveQ);*/
        xDiscardSignal(&yInstanceSetVars->CurrentInSaveQ);
        goto Label_Next_Saved;
      }
      RTOSCALLSIGNALFREEFUNC(yInstanceSetVars->yInSignalPtr);
      RTOSFREE_BUF(&(yInstanceSetVars->yInSignalPtr));
      goto Label_Receive_Signal;
    case xSave :
      /* save signal */
      XOS_TRACE_SAVEADDR
      if (yInstanceSetVars->CurrentInSaveQ != yInstanceSetVars->SaveQ)
        goto Label_Next_Saved;
      xSaveSignal (yInstanceSetVars->SaveQ, yInstanceSetVars->yInSignalPtr);
      goto Label_Receive_Signal;
    default :  /* xInput */
      while ((*yVarP)->ActivePrd != (xPrdNode)0) {
        if ((*yVarP)->ActivePrd->RestartPRD((xPrsNode)(*yVarP), yInstanceSetVars))
          goto Label_New_Transition;
    else if((*yVarP)->ActivePrd == (xPrdNode)0)
          return (xbool)0;
      }
      if ((*yVarP)->RestartPAD == (*yVarP)->PrsNode->NameNode->PAD_Function)
        return (xbool)0;
      RTOSXINPUTRESTARTPAD_CALL
      goto Label_New_Transition_No_Free;
  }
}

#else

#ifndef RTOSXINPUTSIGNAL_SEMS
#define RTOSXINPUTSIGNAL_SEMS
#endif
/*------------------------------------------------------------------------
 *      xInputSignal
 *-----------------------------------------------------------------------*/

extern xbool xInputSignal (xPrsNode *yVarP, int WhereToStart)

{
  RTOSXINPUTSIGNALVARS

  if (WhereToStart == 1) goto Label_New_Transition;
  if (WhereToStart == 2) goto Label_New_Transition_No_Free;
  if ( (*yVarP)->RestartAddress == 0 &&
         ( (*yVarP)->PrsNode == NIL ||
           (*yVarP)->RestartPAD == (*yVarP)->PrsNode->NameNode->PAD_Function
         )
       )
    goto Label_Receive_Signal;
  return (xbool)0;

Label_New_Transition :   /*GLOB*/
  if ((*yVarP)->CurrentInSaveQ != (*yVarP)->SaveQ) {
    xDiscardSignal(&(*yVarP)->CurrentInSaveQ);
  }
  else
    RTOSFREE_BUF(&((*yVarP)->yInSignalPtr));
Label_New_Transition_No_Free:  /*GLOB*/
  (*yVarP)->CurrentInSaveQ = (*yVarP)->SaveQ;
  if ((*yVarP)->RestartPAD != (*yVarP)->PrsNode->NameNode->PAD_Function) {
    (*yVarP)->RestartPAD = (*yVarP)->PrsNode->NameNode->PAD_Function;
    if ( (*yVarP)->pREPLY_Waited_For == (XSIGTYPE)0 )
      return (xbool)1;
  }
Label_Next_Saved :
  (*yVarP)->CurrentInSaveQ = (*yVarP)->CurrentInSaveQ->Suc;
  if ((*yVarP)->CurrentInSaveQ != (*yVarP)->SaveQ) {
    (*yVarP)->yInSignalPtr = RTOSCURRENTINSAVEQ;
    goto Label_Handle_Signal;
  }
Label_Receive_Signal :
  RTOSRECEIVE((*yVarP)->yInSignalPtr,SDL_SELF,0,SDL_NULL)
  if (RTOSSTARTUPSIGNAL == STARTUPSIGNAL) {
     (*yVarP)->RestartPAD = RTOSSTARTUPSIGNAL_PADFUNCTION
     RTOSXINPUTSIGNAL_SEMS
    return (xbool)0;
  }
Label_Handle_Signal :
  switch ( xFindInputAction(RTOSSIGNALNO, (xPrsNode)(*yVarP))) {
    case xNotInSignalSet :
    case xDiscard :
      /* discard signal */
      XOS_TRACE_DISCARDADDR
      if ((*yVarP)->CurrentInSaveQ != (*yVarP)->SaveQ) {
        RTOSCALLSIGNALFREEFUNCSAVEQ((*yVarP)->CurrentInSaveQ);
        xDiscardSignal(&(*yVarP)->CurrentInSaveQ);
        goto Label_Next_Saved;
      }
      RTOSCALLSIGNALFREEFUNC((*yVarP)->yInSignalPtr);
      RTOSFREE_BUF(&((*yVarP)->yInSignalPtr));
      goto Label_Receive_Signal;
    case xSave :
      /* save signal */
      XOS_TRACE_SAVEADDR
      if ((*yVarP)->CurrentInSaveQ != (*yVarP)->SaveQ)
        goto Label_Next_Saved;
      xSaveSignal ((*yVarP)->SaveQ, (*yVarP)->yInSignalPtr);
      goto Label_Receive_Signal;
    default :  /* xInput */
      if ((*yVarP)->RestartPAD == (*yVarP)->PrsNode->NameNode->PAD_Function)
        return (xbool)0;
      if ( ( (*yVarP)->PrsNode->NameNode->PAD_Function == 0 ) &&
	   ( (*yVarP)->PrsNode->NameNode->Super != (xPrsIdNode)0 ) &&
	   ( (*yVarP)->PrsNode->NameNode->Super->EC == xProcessTypeEC ) &&
	   ( (*yVarP)->RestartPAD == 
	                   (*yVarP)->PrsNode->NameNode->Super->PAD_Function ) )
	return (xbool)0;
      (*(*yVarP)->RestartPAD)(*yVarP);
      goto Label_New_Transition_No_Free;
  }
}
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/*---+---------------------------------------------------------------
     xInsertExportedVar
-------------------------------------------------------------------*/

extern void xInsertExportedVar (
  xRemoteVarListNode  ExportedVarNode,
  xRemoteVarIdNode    RemoteVarNode )

{
  ExportedVarNode->Next = RemoteVarNode->RemoteList;
  RemoteVarNode->RemoteList = ExportedVarNode;
}


/*---+---------------------------------------------------------------
     xInsertExportedPrd
-------------------------------------------------------------------*/

extern void xInsertExportedPrd (
  xRemotePrdListNode  ExportedPrdNode,
  xRemotePrdIdNode    RemotePrdNode )

{
  ExportedPrdNode->Next = RemotePrdNode->RemoteList;
  RemotePrdNode->RemoteList = ExportedPrdNode;
}




/*---+---------------------------------------------------------------
     xFindInst
-------------------------------------------------------------------*/

static xEPrsNode xFindInst(
  xPrsIdNode  InPrsType,
  xEPrsNode   InSameBlockInstAs )

{
  xEPrsNode Temp;
  if (InPrsType->InBlockInst != (xBlockIdNode)0 &&
      InSameBlockInstAs != 0 &&
      InSameBlockInstAs->NameNode->InBlockInst == 
        InPrsType->InBlockInst) {
    for (Temp = *InPrsType->ActivePrsList;
         Temp != (xEPrsNode)0;
         Temp = Temp->NextPrs) {
      if (Temp->BlockInstNumber == InSameBlockInstAs->BlockInstNumber)
        return Temp;
    }
    return (xEPrsNode)0;
  }
  return *InPrsType->ActivePrsList;
}


/*---+---------------------------------------------------------------
     xIsInSameInstance
-------------------------------------------------------------------*/

static xbool xIsInSameInstance(
  xIdNode     ParentUnit,
  xPrsIdNode  Importer,
  xPrsIdNode  Exporter )

{
  xIdNode      BlockInstImporter, BlockInstExporter;
  xBlockIdNode BT;

  if (ParentUnit->EC == xProcessTypeEC)
    return (xbool)(Importer == Exporter);

  for (BlockInstImporter = Importer->Parent;
       BlockInstImporter != (xIdNode)0;
       BlockInstImporter = BlockInstImporter->Parent) {
    if (BlockInstImporter->EC == xBlockEC) {
      for (BT = ((xBlockIdNode)BlockInstImporter)->Super;
           BT != (xBlockIdNode)0 && BT != (xBlockIdNode)ParentUnit;
           BT = BT->Super) ;
      if (BT == (xBlockIdNode)ParentUnit) break;
    }
  }
  for (BlockInstExporter = Exporter->Parent;
       BlockInstExporter != (xIdNode)0;
       BlockInstExporter = BlockInstExporter->Parent) {
    if (BlockInstExporter->EC == xBlockEC) {
      for (BT = ((xBlockIdNode)BlockInstExporter)->Super;
           BT != (xBlockIdNode)0 && BT != (xBlockIdNode)ParentUnit;
           BT = BT->Super) ;
      if (BT == (xBlockIdNode)ParentUnit) break;
    }
  }
  if (BlockInstImporter == BlockInstExporter) return (xbool)1;
  return (xbool)0;
}

/*---+---------------------------------------------------------------
     xGetExportingPrs
-------------------------------------------------------------------*/


extern SDL_PId xGetExportingPrs (
  xRemotePrdIdNode RemotePrdNode,
  xEPrsNode         Importer )

{
  xRemotePrdListNode Node;
  xIdNode            ParentUnit;
  xEPrsNode           Prs;

  ParentUnit = RemotePrdNode->Parent;
  if (ParentUnit->EC == xBlocksubstEC) ParentUnit = ParentUnit->Parent;
  for ( Node = RemotePrdNode->RemoteList;
        Node != (xRemotePrdListNode)0;
        Node = Node->Next ) {
    Prs = xFindInst(Node->ExportedPrs, Importer);
    if ( Prs != (xEPrsNode)0 &&
         ( ( ParentUnit->EC != xBlockTypeEC && ParentUnit->EC != xProcessTypeEC ) ||
           xIsInSameInstance(ParentUnit, Importer->NameNode, Node->ExportedPrs)
         )
       )
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      return Prs;
#else
      return Prs->Self;
#endif
  }
  return SDL_NULL;
}


/*---+---------------------------------------------------------------
     xGetEPrsFromType
-------------------------------------------------------------------*/

static xEPrsNode xGetEPrsFromType (
  SDL_PId    P,
  xPrsIdNode PNode )

{
  xEPrsNode Temp;

  for (Temp = *PNode->ActivePrsList;
       Temp != (xEPrsNode)0;
       Temp = Temp->NextPrs) {
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    if (Temp == P) return Temp->VarP->PrsNode;
#else
    if (xEq_SDL_PId(Temp->Self,P)) return Temp->VarP->PrsNode;
#endif
  }
  return (xEPrsNode)0;
}


/*---+---------------------------------------------------------------
     xGetExportAddr
-------------------------------------------------------------------*/

#define XTEMPDATA_SIZE  8
static char xData[XTEMPDATA_SIZE];
  /* Used as return value in xGetExportAddr, SDL_View */



extern void * xGetExportAddr(
  xRemoteVarIdNode RemoteVarNode,
  SDL_PId          P,
  xbool            IsDefP,
  xPrsNode         Importer )

{
  xRemoteVarListNode LoopNode;
  xRemoteVarListNode ExportNode = (xRemoteVarListNode)0;
  xEPrsNode          Prs        = (xEPrsNode)0;
  xbool              IsInError  = (xbool)0;
  xIdNode            ParentUnit;

  if (IsDefP) {
    if (xEq_SDL_PId_NULL(P)) IsInError = (xbool)1;
  }

  if (! IsInError) {
    ParentUnit = RemoteVarNode->Parent;
    if (ParentUnit->EC == xBlocksubstEC) ParentUnit = ParentUnit->Parent;
    for (LoopNode = RemoteVarNode->RemoteList;
         LoopNode != (xRemoteVarListNode)0 && ExportNode == (xRemoteVarListNode)0;
         LoopNode = LoopNode->Next) {
      if (!IsDefP) {
        Prs = xFindInst(LoopNode->ExportingPrs, Importer->PrsNode);
        if ( Prs != (xEPrsNode)0 &&
             ( ( ParentUnit->EC != xBlockTypeEC && ParentUnit->EC != xProcessTypeEC ) ||
               xIsInSameInstance(ParentUnit, Importer->PrsNode->NameNode, 
                                 LoopNode->ExportingPrs)
             )
           ) {
          ExportNode = LoopNode;
        }
      } else {
        Prs = xGetEPrsFromType(P, LoopNode->ExportingPrs);
        if (Prs != (xEPrsNode)0) ExportNode = LoopNode;
      }
    }
  }

  if ( ExportNode == (xRemoteVarListNode)0 ) {
    if (RemoteVarNode->SortSize <= XTEMPDATA_SIZE) {
      memset((void *)xData, 0, RemoteVarNode->SortSize);
      return (void *)xData;
    }
    return xAlloc((xptrint)RemoteVarNode->SortSize);
  }
  return (void *) ((xptrint)Prs->VarP + ExportNode->Offset);
}


/*---+---------------------------------------------------------------
     SDL_View
-------------------------------------------------------------------*/

extern void * SDL_View (
         xViewListRec *VList,     /* list of prs revealing this variable */
         SDL_PId       P,           /* PId expr in view */
         xbool         IsDefP,      /* is PId expression in view() */
         xPrsNode      ViewingPrs,  /* process instance perfoming view */
  xeView(char *        Reveal_Var)  /* viewed variable name as string */
         int           SortSize)    /* size of sort */

{
  xEPrsNode   Prs          = (xEPrsNode)0;
  xbool       IsInError    = (xbool)0;
  int         FoundAtIndex = -1;
  xIdNode     ParentUnit;
  int         Index;

  if (IsDefP) {
    if (xEq_SDL_PId_NULL(P))  IsInError = (xbool)1;
  }

  if (! IsInError) {
    ParentUnit = ViewingPrs->PrsNode->NameNode->Parent;
    if (ParentUnit->EC == xBlocksubstEC) ParentUnit = ParentUnit->Parent;
    for (Index = 0; VList[Index].ViewingPrs != 0 && FoundAtIndex == -1; Index++) {
      if (!IsDefP) {
        Prs = xFindInst(VList[Index].ViewingPrs, ViewingPrs->PrsNode);
        if ( Prs != (xEPrsNode)0 &&
             ( ( ParentUnit->EC != xBlockTypeEC && ParentUnit->EC != xProcessTypeEC ) ||
               xIsInSameInstance(ParentUnit, ViewingPrs->PrsNode->NameNode, 
                                 VList[Index].ViewingPrs)
             )
           ) {
          FoundAtIndex = Index;
        }
      } else {
        Prs = xGetEPrsFromType(P, VList[Index].ViewingPrs);
        if (Prs != (xEPrsNode)0) FoundAtIndex = Index;
      }
    }
  }

  if ( FoundAtIndex == -1 ) {
    if (SortSize <= XTEMPDATA_SIZE) {
      memset((void *)xData, 0, SortSize);
      return (void *)xData;
    }
    return xAlloc((xptrint)SortSize);
  }
  return (void *) ((xptrint)Prs->VarP + VList[FoundAtIndex].Offset);
}


/****+***************************************************************
07   Get and Release of Lists
********************************************************************/

/*---+---------------------------------------------------------------
     xInList
-------------------------------------------------------------------*/ 

extern xbool xInList(
  XSIGTYPE   Id,
  XSIGTYPE  *IdList )

{
  int  I;
  if ( IdList==(XSIGTYPE *)0 )
    return (xbool)0;
  for ( I=0; (IdList[I]!=(XSIGTYPE)0) && (IdList[I]!=Id); I++ ) ;
  return (xbool)(IdList[I]==Id);
}


/*---+---------------------------------------------------------------
     SDL_View_Index
-------------------------------------------------------------------*/

extern int SDL_View_Index (
  xPrsNode      ViewingPrs,  /* process instance perfoming view */
  char *        UniqueVar)  /* variable + prefix for type */

{
  /*          View Reveal is not supported by tight integrations !
  
  xIdNode ParentUnit;
  int Index;
  ParentUnit = ViewingPrs->Parent;
  if (ParentUnit->EC == xBlocksubstEC) ParentUnit = ParentUnit->Parent;
  Index = 0;
  while (((xBlockIdNode)ParentUnit)->ViewIndex[Index].ViewName) {
    if (! strcmp(((xBlockIdNode)ParentUnit)->ViewIndex[Index].ViewName, UniqueVar))
      return ((xBlockIdNode)ParentUnit)->ViewIndex[Index].Index;
    Index++;
  }*/   
  return 0;

}



/****+***************************************************************
14   Path routines
********************************************************************/
#define xSizeOfPathStack 50
xEPrsNode      xEnvPrs;
/*---+---------------------------------------------------------------
     xFindReceiver
-------------------------------------------------------------------*/
 
extern SDL_PId xFindReceiver(
  XSIGTYPE       SignalId,   /* Signal identification */
  xEPrsNode      SenderPrs, /* xEPrsNode for sender */
  xIdNode *ViaList)    /* The via list, i.e. list of xIdNodes */


{
  xIdNode    CPath[xSizeOfPathStack];
  int        CPathLength;
  int        CIndex[xSizeOfPathStack];
  xPrsIdNode SenderId;
  xIdNode    TempId = (xIdNode)0;
  xEPrsNode  Prs;

  if ( SenderPrs != xEnvPrs) {
    SenderId = SenderPrs->NameNode;
    if ( ViaList == (xIdNode *)0 &&
         SenderId != xEnvId      &&
         xInList(SignalId, SenderId->SignalSet) ){
#ifdef X_ONE_TASK_PER_INSTANCE_SET
      return SenderPrs;
#else
      return SenderPrs->Self;
#endif
    }
  } else {
    SenderId = xEnvId;
  }

  CPath[0] = (xIdNode)SenderId;
  CPathLength = 1;
  CIndex[1] = -1;
  while ( CPathLength > 0 ) {
    CIndex[CPathLength]++;
    if ( CPathLength == 1 ) {
      /* CPathLength == 1 means that we start from the sending process */
      if ( ViaList != (xIdNode *)0 ) {
        /* If VIA list then try the items in the list */
        TempId = ViaList[CIndex[1]];
        if (TempId != (xIdNode)0 &&
            ((xChannelIdNode)TempId)->ToId[0] == (xIdNode)SenderId)
          TempId = (xIdNode)((xChannelIdNode)TempId)->Reverse;
        while ( (TempId != (xIdNode)0) && 
                !xInList(SignalId, ((xChannelIdNode)TempId)->SignalSet) ) {
          CIndex[1]++;
          TempId = ViaList[CIndex[1]];
          if (TempId != (xIdNode)0 &&
              ((xChannelIdNode)TempId)->ToId[0] == (xIdNode)SenderId)
            TempId = (xIdNode)((xChannelIdNode)TempId)->Reverse;
        }
      } else {
      /* If not VIA list try all outgoing paths from sending process */
        TempId = SenderId->ToId[CIndex[1]];
        while ( (TempId != (xIdNode)0) && 
                !xInList(SignalId, (TempId->EC==xProcessEC
                                     ?((xPrsIdNode)TempId)->SignalSet
                                     :((xChannelIdNode)TempId)->SignalSet)) ) {
          CIndex[1]++;
          TempId = SenderId->ToId[CIndex[1]];
        }
      }
    } else {
      /* CPathLength != 1 means that we are handling a channel
         a signal route, or a gate */
      TempId = ((xChannelIdNode)CPath[CPathLength-1])->ToId[CIndex[CPathLength]];
    }

    CPath[CPathLength] = TempId;
    if ( TempId == (xIdNode)0 )
      CPathLength--;
    else if ( TempId->EC == xProcessEC) {
       if ( TempId == (xIdNode)xEnvId ||
            CPath[CPathLength-1]->EC == xSignalrouteEC ||
            ( CPath[CPathLength-1]->EC == xGateEC &&
              CPath[CPathLength-1]->Parent->EC == xProcessEC ) ||
             xInList(SignalId, ((xPrsIdNode)TempId)->SignalSet)) {
           /* If implicit signal route check only process
              with signal in SignalSet!!! */
          Prs = xFindInst((xPrsIdNode)TempId, SenderPrs);

          if (Prs != 0)
#ifdef X_ONE_TASK_PER_INSTANCE_SET
             return Prs;
#else
             return Prs->Self;
#endif
          else
             return SDL_NULL;
       }
    } else if ( xInList(SignalId, ((xChannelIdNode)TempId)->SignalSet) ) {
      /* Channel, Signal route, or Gate */
      CPathLength++;
      CIndex[CPathLength] = -1;
    }
  }
  return SDL_NULL;
}

/*---+---------------------------------------------------------------
     xRPCReceiver
-------------------------------------------------------------------*/
 
extern SDL_PId xRPCReceiver(
  SDL_PId        Receiver,
  XSIGTYPE       SignalId,   /* Signal identification */
  xEPrsNode      SenderPrs, /* xEPrsNode for sender */
  xIdNode *ViaList)    /* The via list, i.e. list of xIdNodes */

{
/* ****** Find receiver when output contained no TO clause ****** */
   if ( xEq_SDL_PId_NULL(Receiver) )
     return(xFindReceiver(SignalId, SenderPrs, ViaList));
   else
     return(Receiver);
}

/****+***************************************************************
     Initialization functions
********************************************************************/
  RTOSTASK_TYPE TimerPId;

#ifdef X_SIGNAL_PRIO
extern TAssociationObj AssociationObj;
#endif

/*---+---------------------------------------------------------------
     System_Init_Func
-------------------------------------------------------------------*/
extern RTOSMAINRETURNTYPE RTOSMAINNAME RTOSMAINNAME_PARAM
{
RTOSSYSINITFUNC_VAR
HOOK_MAIN_DECLARATIONS
#ifdef XMSC_TRACE
  SDL_PId SenderPId;
#endif
 
HOOK_MAIN_START_OF_CODE

#ifdef X_SIGNAL_PRIO
  /* Initialization of the intermediate queue- o.s. task table
     needed by signal priority implementation */
  TAOInit (&AssociationObj);
  TAORegisterTask (&AssociationObj, RTOSGETCURRENTTASKID);
#endif
#ifdef TESTENV
  exttask_=create_proc( exttask, "exttask", 8, 1024, USER, 0, OSDEFAULT, OSDEFAULT);
#endif
RTOSSYSINITPR_SEMCREATE
/*mge*/
#ifdef WIN32_INTEGRATION
  RTOSALLOCPRS_SEMCREATE
#endif

/* 3.1 */
  xEnvId = &yEnvR_env;
RTOSENV_PROCID /*L R */
  xInsertIdNode((xIdNode)&yEnvR_env);
#ifdef X_ONE_TASK_PER_INSTANCE_SET
XMSC_TRACE_START()
XCREATE_ENV_PROCESS
RTOSSYSINITFUNC_SDLNULL
#else
RTOSSYSINITFUNC_SDLNULL
XMSC_TRACE_START()
XCREATE_ENV_PROCESS
#endif
#ifndef XNOSTARTUPIDNODE
  xInsertIdNode((xIdNode)&ySigR_Env);
#endif
#ifndef XOPTSORT
  yInit_Predefined();
#endif
/* 3.1 end */
#ifdef WIN32_INTEGRATION
  yInit();
#else
  yInit((xIdNode)0);
#endif

RTOSSYSINITPR_SEMGIVE
HOOK_MAIN_AFTER_PROCESS_RELEASE

Label_Receive_Signal:
RTOSSYSINITPROC_RECEIVE
HOOK_MAIN_AFTER_SIGNAL_RECEPTION 

#ifdef XMSC_TRACE
#ifdef X_ONE_TASK_PER_INSTANCE_SET
  SenderPId = RTOSSYSINITPR_SENDER;
  RTOSSYSINITPR_MSCPRINT
#else
  SenderPId = RTOSSYSINITPR_SENDER;
  RTOSSYSINITPR_MSCPRINT
#endif
#endif
#ifndef XMSC_EDITOR
  printf("Signal to environment is received.\n");
  RTOSFREE_BUF((void **)(&yInSignalPtr));
#endif
#ifdef RTOSTEST
  RTOSTEST_ABORT
#endif
  goto Label_Receive_Signal;

  RTOSMAINRETURNSTMT

}

/*---+---------------------------------------------------------------
     xInitTimer
-------------------------------------------------------------------*/
extern void xInitTimer XPP(( void ))
RTOSXINITTIMER

/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     Avail List for xEPrsNode
-------------------------------------------------------------------*/
static xEPrsNode xAvailListPrs = (xEPrsNode)0;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/

extern xEPrsNode xAllocPrsUseMyMemory( xPrsIdNode  PType )

{
  xEPrsNode R;

  if (xAvailListPrs != (xEPrsNode)0) {
    R = xAvailListPrs;
    xAvailListPrs = R->NextPrs;
  } else {
    R = (xEPrsNode)xAlloc((xptrint)sizeof(xPrsRec));
    R->VarP = xAlloc(PType->VarSize);
  }
  R->NextPrs = *PType->ActivePrsList;
  *PType->ActivePrsList = R;
  R->NameNode = PType;
  R->Self = R;
#ifdef XNRINST
  R->InstNr = PType->NextNr++;
#endif
  return( R);
}

#else
/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/

extern xEPrsNode xAllocPrsUseMyMemory( xPrsIdNode  PType, SDL_PId PId ) 

{
  xEPrsNode R;
RTOSALLOCPRSSEMTAKE

  if (xAvailListPrs != (xEPrsNode)0) {
    R = xAvailListPrs;
    xAvailListPrs = R->NextPrs;
  } else {
    R = (xEPrsNode)xAlloc((xptrint)sizeof(xPrsRec));
  }
  R->NextPrs = *PType->ActivePrsList;
  *PType->ActivePrsList = R;
  R->NameNode = PType;
  R->Self = PId;
#ifdef XNRINST
  R->InstNr = PType->NextNr++;
#endif
RTOSALLOCPRSSEMGIVE
  return( R);
}
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */
/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/

extern xEPrsNode xAllocPrs( xPrsIdNode  PType, SDL_PId PId )


RTOSXALLOCPRS

/*---+---------------------------------------------------------------
     xFreePrs
-------------------------------------------------------------------*/

extern void xFreePrs( xEPrsNode  *Prs ) 

{
  xEPrsNode  yTempPrs;
RTOSALLOCPRSSEMTAKE
  yTempPrs = *(*Prs)->NameNode->ActivePrsList; 
  if (yTempPrs == (*Prs))
    *(*Prs)->NameNode->ActivePrsList = (*Prs)->NextPrs;
  else { 
    while (yTempPrs->NextPrs != (*Prs))
      yTempPrs = yTempPrs->NextPrs; 
    yTempPrs->NextPrs = (*Prs)->NextPrs;
  }

  /* Free local variables */
  if ((*Prs)->NameNode->Free_Vars != 0)
    (*Prs)->NameNode->Free_Vars((void *)(*Prs)->VarP);
  else if ((*Prs)->NameNode->Super!= 0 && (*Prs)->NameNode->Super->Free_Vars !=0)
    (*Prs)->NameNode->Super->Free_Vars((void *)(*Prs)->VarP);

#ifndef X_NO_AVAILLISTPRS 
  (*Prs)->NextPrs = xAvailListPrs;
  xAvailListPrs = (*Prs);
#else
  xFree((void**)Prs);
#endif
RTOSALLOCPRSSEMGIVE
}


/****+***************************************************************
     SDL Procedures
********************************************************************/

/*---+---------------------------------------------------------------
     xGetPrd
-------------------------------------------------------------------*/

extern xPrdNode xGetPrd(
  xPrdIdNode  PrdId )

{
  xPrdNode R;

  R = (xPrdNode)xAlloc((xptrint)PrdId->VarSize);
  R->NameNode = PrdId;
  R->RestartAddress = START_STATE_PRD;
  R->RestartPRD = PrdId->Assoc_Function;
  return R;
}


/*---+---------------------------------------------------------------
     xReleasePrd
-------------------------------------------------------------------*/

extern void xReleasePrd(
  xPrsNode VarP ) 

{
  xPrdNode  PrdP;

  PrdP = VarP->ActivePrd;
  VarP->ActivePrd = PrdP->DynamicFather;

  /* Free local variables */
  if (PrdP->NameNode->Free_Vars != 0)
      PrdP->NameNode->Free_Vars((void *)PrdP);

  xFree((void **)&PrdP);
}



/*---+---------------------------------------------------------------
     xAddPrdCall
-------------------------------------------------------------------*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET

extern void xAddPrdCall(
  xPrdNode   R,
  xPrsNode   VarP,
  int        StaticFatherLevel,
  int        RestartAddress )



#else


extern void xAddPrdCall(
  xPrdNode   R,
  xPrsNode   VarP,
  int        StaticFatherLevel )

#endif
{
  xPrdNode  TempStaticFather;
  int       i;

  if ( VarP->ActivePrd == (xPrdNode)0 ) {
    R->DynamicFather = (xPrdNode)0;
    R->StaticFather = (xPrdNode)0;
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    VarP->RestartAddress = RestartAddress;
#endif
  } else {
    R->DynamicFather = VarP->ActivePrd;
    if (StaticFatherLevel >= 0) {
      TempStaticFather = R->DynamicFather;
      for (i = 1; i<=StaticFatherLevel; i++)
        TempStaticFather = TempStaticFather->StaticFather;
      R->StaticFather = TempStaticFather;
    }
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    VarP->ActivePrd->RestartAddress = RestartAddress;
#endif
  }
  VarP->ActivePrd = R;
}


/****+***************************************************************
     SDL PId
********************************************************************/

  SDL_PId    SDL_NULL;
  xPrsIdNode xEnvId;
  SDL_PId    xEnvPId;

/****+***************************************************************
     SDL Timers
********************************************************************/


/*---+---------------------------------------------------------------
     xSDLActiveInTimerProcess
-------------------------------------------------------------------*/

void xSDLActiveInTimerProcess( RTOSTIMER_DEF yInSignalPointer, 
                   RTOSTIMER_DEF TimerQ)

{
  RTOSTIMER_DEF TempTimer;
  /*  SDL_PId   TempSender;*/
  RTOSACTIVEINTIMERPROCESS_VARS

  /* Scan TimerQ to see if timer is there. */
  TempTimer = RTOSTIMERQ_PRE;
  while (TempTimer != TimerQ &&
          (!xEq_SDL_PId(RTOSTEMPTIMERSIGNAL_RECEIVER, RTOSTIMERSENDER) ||
          RTOSTEMPTIMERSIGNAL_SIGNO != RTOSXACTIVETIMER_TIMERTOFIND)) {
    TempTimer = RTOSTEMPTIMER_PRE;
  }
  /*  while (TempTimer != TimerQ &&
         (xEq_SDL_PId(TempSender,RTOSTIMERSENDER)),
          !xEq_SDL_PId(RTOSTEMPTIMERSIGNAL_RECEIVER, TempSender) ||
          RTOSTEMPTIMERSIGNAL_SIGNO != RTOSXACTIVETIMER_TIMERTOFIND) {
    TempTimer = RTOSTEMPTIMER_PRE;
  }*/

  /* If timer has been found, remove it and free data area. */
  if (TempTimer != TimerQ) {
    RTOSXACTIVETIMER_TIMERTOFIND = TimerWasFound;
  }

  /* Reply to process */
  RTOSSENDTIMERALLOCREPLY
  RTOSSENDTIMER(&yInSignalPointer,RTOSTIMERSENDER2);

}

/*---+---------------------------------------------------------------
     xSDLActive
-------------------------------------------------------------------*/

extern xbool xSDLActive RTOSXSDLACTIVE_PARAMETERS
{
  RTOSXSDLACTIVE_VARS

  yTimerActive = RTOSXSDLACTIVE_ALLOC
  RTOSXACTIVETIMER_TIMERTOFIND_2 = TimerName;
  RTOSSENDTIMERALLOC
  RTOSSENDTIMER( &yTimerActive, RTOSTIMER_QUEUEID);

  /* Wait for reply from timer process */
  RTOSXSDLACTIVE_WAITREPLY

  /* Look in the saveQ */
  TempSaved = SaveQ->Suc;
  while (TempSaved != SaveQ) {
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    if ((RTOSTEMPSAVED_SIGNO == TimerName ) && (xEq_SDL_PId(RTOSTEMPSAVED_RECEIVER,Self))) {
#else
    if (RTOSTEMPSAVED_SIGNO == TimerName ) {
#endif
      if (TempSaved != CurrentInSaveQ)
    return( SDL_True);
      else
    return( SDL_False); 
      /* This case means the timer has already been received, 
     but it isn't removed from the save queue yet. */      
    }
    else
      TempSaved = TempSaved->Suc;
  }

  /* See if timer is in input port */
  RTOSLOOK_FOR_TIMER
  while ( RTOSMSG_IN_Q ) {
    RTOSALLOCMESS
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    if ((RTOSYTIMERACTIVE_SIGNO == TimerName ) && (xEq_SDL_PId(RTOSYTIMERACTIVE_RECEIVER,Self))) {
#else
    if (RTOSYTIMERACTIVE_SIGNO == TimerName ) {
#endif
      /*    if (RTOSYTIMERACTIVE_SIGNO == TimerName) { */
      /* Timer found, put in SaveQ and return */
      xSaveSignal( SaveQ,(RTOSSIGNAL_DEF) yTimerActive);
      return( SDL_True);
    }
    else {
      /* Other signal or timer found, put them in SaveQ and continue */
      xSaveSignal( SaveQ,(RTOSSIGNAL_DEF) yTimerActive);
    }
    RTOSLOOK_FOR_TIMER
  }
  return( SDL_False);
}

/*---+---------------------------------------------------------------
     xRemoveTimers
-------------------------------------------------------------------*/

void xRemoveTimers(RTOSTIMER_DEF yInSignalPointer, RTOSTIMER_DEF TimerQ)

{
  RTOSTIMER_DEF TempTimer;
  RTOSTIMER_DEF HelpTempTimer;
  SDL_PId        TempSender;

  /* Scan TimerQ for timers that should be removed. */
  TempSender = RTOSTIMERSENDER;
  TempTimer = RTOSTIMERQ_PRE;
  while (TempTimer != TimerQ) {
    if (xEq_SDL_PId(RTOSTEMPTIMERSIGNAL_RECEIVER, TempSender)) {
      /* Remove timer */
      HelpTempTimer = TempTimer;
      TempTimer = RTOSTEMPTIMER_PRE;
      RTOSHELPTEMPTIMER_SUC_PRE = RTOSHELPTEMPTIMER_PRE;
      RTOSHELPTEMPTIMER_PRE_SUC = RTOSHELPTEMPTIMER_SUC;
      RTOSFREE_BUF(&HelpTempTimer);
    }
    else
      TempTimer = RTOSTEMPTIMER_PRE;
  }

  RTOSFREE_BUF(&yInSignalPointer);

}

/*---+---------------------------------------------------------------
     xSDLResetInTimerProcess
-------------------------------------------------------------------*/

void xSDLResetInTimerProcess(RTOSTIMER_DEF yInSignalPointer ,RTOSTIMER_DEF TimerQ, RTOSTIMER_DEF *TimerWrapPtr)

{
  RTOSTIMER_DEF TempTimer;
  RTOSXSDLRESETINTIMERPROCESS_VARS

  
  /* Scan TimerQ for timer that should be removed. */
  TempTimer = RTOSTIMERQ_PRE;
  while (TempTimer != TimerQ) {
    if (xEq_SDL_PId(RTOSTEMPTIMERSIGNAL_RECEIVER, RTOSTIMERSENDER))
      if (RTOSTEMPTIMERSIGNAL_SIGNO == RTOSXRESETTIMER_TIMERTORESET)
         RTOSCHECKEQPARAM_INTIMER
          break;
     TempTimer = RTOSTEMPTIMER_PRE;
  }


  /* If timer has been found, remove it and free data area. */
  if (TempTimer != TimerQ) {
    if(*TimerWrapPtr == TempTimer && RTOSTIMERWRAPPTR_SUC !=TimerQ) { 
		/* TimerWrapPtr points to Timer that is to be removed. Change TimerWrapPtr to next timer. */ 
		(*TimerWrapPtr) = RTOSTIMERWRAPPTR_SUC; 
	} else if(*TimerWrapPtr == TempTimer && RTOSTIMERWRAPPTR_SUC ==TimerQ){ 
			/* Last in Queue */ 
		(*TimerWrapPtr)=NULL; 
	} 
    RTOSTEMPTIMER_SUC_PRE = RTOSTEMPTIMER_PRE;
    RTOSTEMPTIMER_PRE_SUC = RTOSTEMPTIMER_SUC;
#ifdef XMSC_TRACE
    RTOSXRESETTIMER_SIGNALID = RTOSTEMPTIMERSIGNAL_SIGNALID;
#endif
    RTOSFREETIMERSTRINGPARAMS2((xTimerHeader)TempTimer);
    RTOSFREE_BUF(&TempTimer);
    RTOSXRESETTIMER_TIMERTORESET = TimerWasFound;
  }
  /* Reply to process */
  RTOSXSDLRESETINTIMERPROCESS_REPLY
}

/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/

extern void xSDLReset RTOSXSDLRESET_PARAMETERS
{
  RTOSXSDLRESET_VARS

  RTOSXSDLRESET_INIT

  /* Wait for reply from timer process */
  RTOSXSDLRESET_WAITREPLY

  /* Look in the saveQ */
  TempSaved = SaveQ->Suc;
  while (TempSaved != SaveQ) {
#ifdef X_ONE_TASK_PER_INSTANCE_SET
    if ((RTOSTEMPSAVED_SIGNO == TimerName ) && (xEq_SDL_PId(RTOSTEMPSAVED_RECEIVER,Self))) {
#else
    if (RTOSTEMPSAVED_SIGNO == TimerName ) {
#endif
      if(RTOSTEMPSAVED!=InSignalPtr) {
        RTOSCHECKEQPARAM
        xDiscardSignal(&TempSaved);
        return;
        }
      }
      else {
        RTOSCHECKEQPARAM2
        return;
        }
     }
    }
    TempSaved = TempSaved->Suc;
  }

  /* Remove timer from input port */
  RTOSXSDLRESET_REMOVETIMER
}

/*---+---------------------------------------------------------------
     xSDLSet
-------------------------------------------------------------------*/

void xSDLSet(RTOSTIMER_DEF yInSignalPointer, RTOSTIMER_DEF TimerQ,
          RTOSTIMER_DEF *TimerWrapPtr, SDL_Duration TimeNow)

{
  RTOSOSTIME     TimeExpr;
  RTOSTIMER_DEF TempTimer;

  RTOSSET_SIGNALCODE

  TimeExpr = RTOSTEMPTIMERSIGNAL_TIMERTIME + TimeNow;
  RTOSTEMPTIMERSIGNAL_TIMERTIME = TimeExpr;

  if (TimeExpr < TimeNow) {
    /* This timer must not fire until the clock has wrapped */
    TempTimer = RTOSTIMERQ_PRE;
    if (*TimerWrapPtr==NULL) {
      *TimerWrapPtr=yInSignalPointer; /* Place last, no other wrapped timers */
    } else {
      while (TimeExpr < RTOSTEMPTIMER_TIMERTIME &&
         RTOSTEMPTIMER_SUC != *TimerWrapPtr) {
    TempTimer = RTOSTEMPTIMER_PRE; /* Sort among wrapped timers */
      }
      if (RTOSTEMPTIMER_SUC == *TimerWrapPtr)
    *TimerWrapPtr=yInSignalPointer; /* New lowest wrapped timer */
    }
  } else {
  /* Locate proper place to insert timer signal. */
    if(*TimerWrapPtr!=NULL) {
      /* Ignore low timer vals at the end of the queue that */
      /* shouldn't be fired until the clock has wrapped */
      TempTimer = RTOSTIMERWRAPPTR_PRE;
    } else
      TempTimer = RTOSTIMERQ_PRE;
    while (TimeExpr < RTOSTEMPTIMER_TIMERTIME) {
      TempTimer = RTOSTEMPTIMER_PRE;
    }
  }

  /* Insert timer signal */
  RTOSTEMPTIMERSIGNAL_PRE = TempTimer;
  RTOSTEMPTIMERSIGNAL_SUC = RTOSTEMPTIMER_SUC;
  RTOSTEMPTIMER_SUC_PRE = yInSignalPointer;
  RTOSTEMPTIMER_SUC = yInSignalPointer;  
}

/*---+---------------------------------------------------------------
     TimerTask
-------------------------------------------------------------------*/
extern RTOSXTIMERTASK_RTNTYPE xTimerTask XPP ((RTOSXTIMERTASK_PARAM))
{
  RTOSTIMER_DEF TimerQ;
  RTOSTIMER_DEF yInSignalPointer;
  RTOSTIMER_DEF yOutputSignalPtr;
  RTOSTIMER_DEF TimerWrapPtr=NULL;
  XSIGNALHEADERTYPE AllSignals[] = {0};
  RTOSTIMERTASK_VAR

  RTOSOSTIME    CurrentTime,PreviousTime;

#if defined(OSSIM) && defined(SunOS)
  PreviousTime = RTOSSDLNOW1;
#else
  PreviousTime = RTOSSDLNOW2;
#endif

  RTOSTIMERTASKALLOC_Q
  RTOSTIMERQ_PRE = TimerQ;
  RTOSTIMERQ_SUC = TimerQ;
  RTOSTIMERQ_RECEIVER = SDL_NULL;
  RTOSTIMERQ_TIMERTIME = 0;


 /* Major task loop */
  while (1) {

    yInSignalPointer = NIL;

    RTOSTIMERTASKALLOC_INSIGNAL
    if (RTOSTIMERQ_SUC == TimerQ) { 
      /* No timer in TimerQ, wait for any signal */
      RTOSTIMERRECEIVE(yInSignalPointer,NULL,0,SDL_NULL)
#if defined(OSSIM) && defined(SunOS)
      RTOSGETCURRENTTIME1
#else
      RTOSGETCURRENTTIME2
#endif
    }
    else {
#if defined(OSSIM) && defined(SunOS)
      RTOSGETCURRENTTIME1
#else
      RTOSGETCURRENTTIME2
#endif
      if (CurrentTime < PreviousTime) {
        if (TimerWrapPtr == NULL) {
            TimerWrapPtr = TimerQ;
        }   
        /* Expire all timers that should have timed out */
        while(RTOSTIMERQ_SUC != TimerWrapPtr) {
            yOutputSignalPtr = RTOSTIMERQ_SUC;
            RTOSTIMERQ_SUC = RTOSXTIMER_SUC;
            RTOSTIMERQ_SUC_PRE = TimerQ;
#ifndef WIN32_INTEGRATION       
            RTOSSENDTIMERALLOCTIMER
#endif
            RTOSSENDTIMER(&yOutputSignalPtr, RTOSOUTPUTSIGNAL_RECEIVER);
            RTOSSENDTIMERFREE_OUTPUT
        }
    TimerWrapPtr=NULL; /* The clock has wrapped. Make it */
                       /* possible for timers that have */
                       /* been blocked to fire */
      }

      PreviousTime = CurrentTime;
      if (RTOSTIMERQ_SUC_TIMERTIME <= CurrentTime && 
          TimerWrapPtr != RTOSTIMERQ_SUC && RTOSTIMERQ_SUC != TimerQ ) {
        /* Timeout, handle first timer in timer list */
        yOutputSignalPtr = RTOSTIMERQ_SUC;
        RTOSTIMERQ_SUC = RTOSXTIMER_SUC;
        RTOSTIMERQ_SUC_PRE = TimerQ;
#ifndef WIN32_INTEGRATION       
        RTOSSENDTIMERALLOCTIMER
#endif
        RTOSSENDTIMER(&yOutputSignalPtr, RTOSOUTPUTSIGNAL_RECEIVER);
        RTOSSENDTIMERFREE_OUTPUT
       /* RTOSFREE_BUF(&yInSignalPointer);*/
       /* yInSignalPointer = NIL;*/
      }
      else {
        /* Compute time in ticks for next timeout */
#if defined(OSSIM) && defined(SunOS)
        yInSignalPointer = RTOSRECEIVE_MESSAGE1;
#else
        /* Will result in yInSignalPointer being set if a set/reset/active message being received */
        /* otherwise yInSignalPointer will be set to NIL if a timeout is received */
        RTOSRECEIVE_MESSAGE2;
#endif
      }
    }

    
    if (yInSignalPointer != NIL) { 
      /* A set, reset or active signal is received */
      if (RTOSTEMPTIMERSIGNAL_SIG_NO == ResetTimer) {
        xSDLResetInTimerProcess( yInSignalPointer, TimerQ, &TimerWrapPtr );
      }
      else if (RTOSTEMPTIMERSIGNAL_SIG_NO == ActiveTimer) {
        xSDLActiveInTimerProcess( yInSignalPointer, TimerQ);
      }
      else if (RTOSTEMPTIMERSIGNAL_SIG_NO == RemoveTimers) {
        xRemoveTimers( yInSignalPointer, TimerQ);
      }
      else if (RTOSTEMPTIMERSIGNAL_SIG_NO == 31992){
        xSDLSet( yInSignalPointer, TimerQ, &TimerWrapPtr, CurrentTime);
      }
      else
          {
   /* RTOSSENDTIMERFREE_OUTPUT*/
        RTOSFREE_BUF(&yInSignalPointer);
        yInSignalPointer=NIL;
        }
    }
  } /* End while(1) */
}

/*---+---------------------------------------------------------------
     xTo_Process
-------------------------------------------------------------------*/

extern SDL_PId xTo_Process(xPrsIdNode PrsNode  )

{
  return( *(PrsNode)->ActivePrsList != (xEPrsNode)0
     ? (*(PrsNode)->ActivePrsList)->Self : SDL_NULL);
}

#ifdef X_ONE_TASK_PER_INSTANCE_SET
/*---+---------------------------------------------------------------
     xHandle_Sig
-------------------------------------------------------------------*/

extern void xHandle_Sig(RTOSSIGNAL_DEF OutputSignal,SDL_PId Sender,int SigPar_Size, 
SDL_PId Receiver, RTOSTASK_TYPE ReceiverTask RTOSHANDLEMESS_TYPE)

{
  RTOSXHANDLESIG_BODY
}
#endif /* X_ONE_TASK_PER_INSTANCE_SET */

/*---+---------------------------------------------------------------
     xHandle_Timer
-------------------------------------------------------------------*/

extern void xHandle_Timer(RTOSSIGNAL_DEF OutputSignal,SDL_Duration Dur_Expr, SDL_PId Sender)

{
#ifdef XTORNADOINT
  ((xTimerHeader)OutputSignal)->IsTornadoTimer = 1;
  ((xTimerHeader)OutputSignal)->SignalId = SignalId++;
#endif /*XTORNADOINT*/
  RTOSXHANDLETIMER_BODY
}

/*---+---------------------------------------------------------------
     xProc2PId
-------------------------------------------------------------------*/
/*

extern SDL_PId xProc2PId(PROCESS exttaskproc, SDL_PId exttaskpid)

{
  exttaskpid = xAlloc(sizeof(xEPrsRec));
  exttaskpid->NameNode = xAlloc(sizeof(xPrsIdRec));
  exttaskpid->NameNode->PROCID = exttaskproc;
  return exttaskpid;
}
Removed in LRA's file */

/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/
RTOSRTOSPAD_ENV
/**************************************************************/
/*        FUNCTIONS USED FOR PARTITIONING OF SYSTEMS          */
/**************************************************************/

/*---+---------------------------------------------------------------
     xAddToEnv
-------------------------------------------------------------------*/

extern void xAddToEnv(
  xChannelIdNode   ChanId)
{
  static int Remains = XTRACHANNELSTOENV;
  int i;

#ifndef XFIXED_SIZE_ENV_LIST
  static int AddIfNeeded = 20;
  xIdNode *OldList;
  for (i=0; xEnvId->ToId[i] != (xIdNode)0; i++)
    ;
  if (Remains == 0) {
    OldList = xEnvId->ToId;
    xEnvId->ToId = (xIdNode *)xAlloc(sizeof(xIdNode *) * (i+AddIfNeeded));
    for (i=0; OldList[i] != (xIdNode)0; i++)
      xEnvId->ToId[i] = OldList[i];
    if (AddIfNeeded > 20)
      xFree((void **)&OldList);   /* Do not free first one, as it is not allocated */
    Remains = AddIfNeeded;
    AddIfNeeded = AddIfNeeded*2;
  }
  xEnvId->ToId[i] = (xIdNode)ChanId;
  Remains--;

#else

  if (Remains == 0) {
#ifdef XREADANDWRITEF
    xPrintString("Too many channels added to Env, terminating ...\n");
#endif
    exit(1);
    /* If your program exits here, you should redefine XTRACHANNELSTOENV
       to a larger value and redefine XTRACHANNELLIST to an approriate
       number of zeroes */
  }
  for (i=0; xEnvId->ToId[i] != (xIdNode)0; i++)
    ;
  xEnvId->ToId[i] = (xIdNode)ChanId;
  Remains--;
#endif
}

