/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:49 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1999, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/******************************************************************

  C-code macros for RTOS-integrations

  To be used with Cadvanced SDL to C Compiler 4.6
   
Licensed Materials - Property of IBM

(c) Copyright IBM Corporation 1993, 2012. All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

*******************************************************************/

#ifndef _scttypes_h
#define _scttypes_h

#define xThreadName(a)

#ifdef USER_CONFIG
#include "sct_mcf.h"
#endif

#define XCAT(P1,P2)     P1##P2

#ifdef OSE_INTEGRATION
#include "sctose.h"
#endif
#ifdef OSE_D_INTEGRATION
#include "sctose_d.h"
#endif
#ifdef VXWORKS_INTEGRATION
#include "sctvxworks.h"
#endif
#ifdef PSOS_INTEGRATION
#include "sctpsos.h"
#endif
#ifdef CHORUS_INTEGRATION
#include "sctchorus.h"
#endif
#ifdef WIN32_INTEGRATION
#include "sctwin32.h"
#endif
#ifdef VRTX_INTEGRATION
#include "sctvrtx.h"
#endif
#ifdef QNX_INTEGRATION
#include "sctqnx.h"
#endif
#ifdef NEUTRINO_INTEGRATION
#include "sctneutrino.h"
#endif
#ifdef SOLARIS_INTEGRATION
#include "sctsolaris.h"
#endif
#ifdef NUCLEUS_INTEGRATION
#include "sctnucleus.h"
#endif

/* Include hooks for external code. You will find a template for scthooks.h */
/* in <sdtdir>/RTOS/INCLUDE. This file can be used without modifications,   */
/* if you don't need to hook in any external code (all macros are empty).   */
/* You must at least include this "empty" file, otherwise some files will   */
/* not compile at all.                                                      */
#ifdef XNOINCLUDE_SCTHOOKS	
#define HOOK_GLOBAL_DECLARATIONS
#define HOOK_MAIN_DECLARATIONS
#define HOOK_MAIN_START_OF_CODE
#define HOOK_MAIN_AFTER_PROCESS_RELEASE
#define HOOK_MAIN_AFTER_SIGNAL_RECEPTION
#else
#include "scthooks.h"
#endif


#ifdef XSCT_CBASIC
C_Basic_generator_cannot_be_used_for_applications;
#endif

#ifndef XNO_VERSION_CHECK
#ifdef XENABLE_VERSION_CHECK
#if defined(XSCT_CBASIC) || defined(XSCT_CADVANCED)
#ifndef SCT_VERSION_6_3
#error Version_of_code_generator_and_library_does_not_match;
#endif
#endif
#endif
#endif

/****+***************************************************************
     Utility macros
********************************************************************/
 

#define COMMENT(P)
/* to be used for inserting comments in in-line C-code in SDL.
   the syntax is: COMMENT(( your free format comment text )) */


/****+***************************************************************
     General macros
********************************************************************/

#ifndef XTRACHANNELSTOENV
#define XTRACHANNELSTOENV  0
#define XTRACHANNELLIST
#endif

/* FOR TESTING PURPOSE */
extern int myrandom;
#define GETINTRAND      myrandom++
#define GETINTRAND_MAX  2147483647

#ifndef xOffsetOf
#define xOffsetOf(type, field)  ((xptrint) &((type *) 0)->field)
#endif

#define XALLOC(SIZE,SORTIDNODE) xAlloc(SIZE)
#define XFREE(P,SIZE)           xFree(P)

#define XTRACHANNELLIST

typedef struct xPrsStruct  *xPrsNode;
typedef struct xPrdStruct  *xPrdNode;
#define XPRSNODE xEPrsNode

typedef XCONST struct xBlockSubstIdStruct *xBlockSubstIdNode;
typedef        struct xPackageIdStruct    *xPackageIdNode;
typedef XCONST struct xSystemIdStruct     *xSystemIdNode;
#ifndef XOPTCHAN
typedef XCONST struct xChannelIdStruct    *xChannelIdNode;
#endif
typedef XCONST struct xBlockIdStruct      *xBlockIdNode;
typedef XCONST struct xPrdIdStruct        *xPrdIdNode;
typedef        struct xRemotePrdIdStruct  *xRemotePrdIdNode;
typedef XCONST struct xStateIdStruct      *xStateIdNode;
typedef        struct xRemoteVarIdStruct  *xRemoteVarIdNode;

extern RTOSTASK_TYPE    TimerPId;

typedef unsigned char xInputAction;
#define xNotInSignalSet  (xInputAction)0
#define xInput           (xInputAction)1
#define xSave            (xInputAction)2
#define xDiscard         (xInputAction)3
#define xEnablCond       (xInputAction)4
#define xPrioInput       (xInputAction)5

#ifdef XOPTSIGNALALLOC
#define XTIMERHEADERTYPE xTimerHeaderRec
#define XSIG_EXTRAS
#endif

#ifndef XOPTSIGNALALLOC
#define XNOSIGNALIDNODE
#define XNOSTARTUPIDNODE
#endif

#ifdef xxx
#define XNOREMOTEVARIDNODE
#define XNOEXPORTEDIDNODE
#endif
#define XOPTSIGPARA
#define XOPTDCL
#define XOPTFPAR
#define XOPTSTRUCT
#define XOPTLIT
#define XOPTSORT
#define XNOUSEOFSERVICE

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XCASEAFTERPRDLABELS
#endif

#define XPROCESSMAIN(PAD)
#define XNOPROCATSTARTUP
#define XNOCONTSIGFUNC
/*
#define XNOEQTIMERFUNC
*/
#define XPRSPRIO

#define XFREEVARS
#ifdef XFREEVARS
#ifndef XFREEFUNCS
#define XFREEFUNCS
#endif
#endif
#ifdef XFREEVARS
#define FREE_PROCESS_VARS
#endif

/* #define XNOMAIN */ /* 3.1 */

#define xPrsPrioPar(p) , p
#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
#define xSigPrioPar(p)  , p
#define xSigPrioParS(p)  p;
#else
#define xSigPrioPar(p)
#define xSigPrioParS(p)
#endif

#define xTestF(p)
#define xRaWF(p)
#define xFreF(p)
#define xFreS(p)
#define xAssF(p)
#define xEqF(p)
#ifdef XOSETRACE
#define xIdNames(p) , p
#else
#define xIdNames(p)
#endif /*XOSETRACE*/
#ifndef XOPTCHAN
#define xOptChan(p)  , p
#define xOptChanZ(p)   p
#else
#define xOptChan(p)
#define xOptChanZ(p)   0
#endif
#define xBreakB(p)
#define xTrace(p)
#define xGRTrace(p)
#define xMSCETrace(p)
#define xCoverage(p)
#define xNrInst(p)
#define xSymbTLink(p1, p2)
#define xeView(p)
#define xeViewS(p)
#define xCTrace(p)
#define xCTraceS(p)
#ifndef XNOUSEOFSERVICE
#define xService(p)  , p
#else
#define xService(p)
#endif

#ifndef xDefaultPrioProcess
#define xDefaultPrioProcess      RTOSPRIODEFAULT
#endif

#ifndef xDefaultPrioSignal
#define xDefaultPrioSignal       RTOSPRIODEFAULT
#endif

#ifndef xDefaultPrioTimerSignal
#define xDefaultPrioTimerSignal  RTOSPRIODEFAULT
#endif

#ifndef xDefaultPrioContSignal
#define xDefaultPrioContSignal   RTOSPRIODEFAULT
#endif

#ifndef xDefaultPrioCreate
#define xDefaultPrioCreate       RTOSPRIODEFAULT
#endif

#ifndef XINPUTREFTYPE
#define XINPUTREFTYPE int
#endif
/* If fewer than 128 inputs int could be changed to unsigned char
   so save memory */

extern void xAddToEnv XPP((xChannelIdNode));


/****+***************************************************************
     Macros to Implement SDL
********************************************************************/

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOPTSIGNALALLOC
#define XSYSTEMVARS \
xIdNode         xSymbolTableRoot; \
struct xSignalIdStruct TimerIdDummy = \
{xTimerEC ,(xIdNode)0 ,(unsigned) sizeof (xTimerHeaderRec), 0, 0 };

#else

#define XSYSTEMVARS \
xIdNode         xSymbolTableRoot;
#endif
#define XSYSTEMVARS_H

#define XPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME,PAD_FUNCTION, VDEF_TYPE)

#define XPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE)

#else

#ifdef XOPTSIGNALALLOC
#define XSYSTEMVARS \
xIdNode         xSymbolTableRoot; \
struct xSignalIdStruct TimerIdDummy = \
{xTimerEC ,(xIdNode)0 ,(unsigned) sizeof (xTimerHeaderRec), 0, 0 };
#else
#define XSYSTEMVARS \
xIdNode     xSymbolTableRoot;
#endif

#define XSYSTEMVARS_H
#define XPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
RTOSXPROCESSDEF_C(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) 

#define XPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE) \
RTOSXPROCESSDEF_H(PROC_NAME, PROC_NAME_STRING, PREFIX_PROC_NAME, PAD_FUNCTION, VDEF_TYPE)

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */


#define XSIGTYPE int
#define xSigCode(P) 
#define SIGCODE(P)
#define STARTUPSIGNAL       32000

/* ----------------- Extra components in IdNodes ----------------- */

  /* All nodes */
#define XCOMMON_EXTRAS

  /* System, system type */
#define XSYS_EXTRAS

  /* Package */
#define XPAC_EXTRAS

  /* Block, Block type */
#define XBLO_EXTRAS

  /* Block substructure */
#define XBLS_EXTRAS


  /* Procedure */
#define XPRD_EXTRAS

  /* Channel, signal route, gate */
#define XCHA_EXTRAS

  /* State */
#define XSTA_EXTRAS
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XPAD_STRUCT_COMP void (*RestartPAD) XPP((void *,xPrsInstanceSetVars * ));
#define XPRD_STRUCT_COMP xbool (*RestartPRD) XPP (( ));
#else
#define XPAD_STRUCT_COMP void (*RestartPAD) XPP(( void *VarP ));
#define XPRD_STRUCT_COMP xbool (*RestartPRD) XPP (( void *VarP ));
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define INSIGNAL_PTR yInstanceSetVars->yInSignalPtr
#define ENV_PID      xEnvPrs
#else
#define INSIGNAL_PTR yVarP->yInSignalPtr
#define ENV_PID      xEnvPId
#endif
/* ---------------- Variables in the PAD function ---------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define PROCESS_VARS \
   int            RestartAddress; \
   xPrdNode       ActivePrd; \
   RTOSXPAD_STRUCT_COMP \
   SDL_PId        Parent; \
   SDL_PId        Offspring; \
   SDL_PId        Sender; \
   int            State; \
   int            StateAfterRPC; \
   xEPrsNode      PrsNode; /* used as self */ \
   XSIGTYPE       pREPLY_Waited_For;

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define PROCEDURE_VARS \
   xPrdIdNode   NameNode; \
   xPrdNode     StaticFather; \
   xPrdNode     DynamicFather; \
   int          RestartAddress; \
   int          State; \
   int          StateAfterRPC; \
   XPRD_STRUCT_COMP


#define XEND_PRD return (xbool)0;

#define XNAMENODE      yVarP->PrsNode->NameNode
#define XNAMENODE_PRD  yPrdVarP->NameNode

#define YPAD_YSVARP \
   void *  ySVarP;

#define YPAD_YVARP(VDEF_TYPE) \
   VDEF_TYPE *yVarP = (VDEF_TYPE *)VarP;

#define YPRD_YVARP(VDEF_TYPE) \
   VDEF_TYPE *yVarP = (VDEF_TYPE *)VarP;

#define YGLOBALPRD_YVARP \
   xPrsNode yVarP = (xPrsNode)VarP;

#define SDL_PARENT              yVarP->Parent
#define SDL_OFFSPRING           yVarP->Offspring
#define CURRENT_STATE           yVarP->State
#define CURRENT_STATE_PRD       yPrdVarP->State


/* ------------------ Structure of PAD function ------------------ */

#ifndef X_ONE_TASK_PER_INSTANCE_SET


#define YPAD_PROTOTYPE(PAD)     void PAD ( void *VarP );
#define YPAD_FUNCTION(PAD)      void PAD ( void *VarP )
#define YPRD_PROTOTYPE(PAD)     xbool PAD ( void *VarP );
#define YPRD_FUNCTION(PAD)      xbool PAD ( void *VarP ) 

#endif                /* X_ONE_TASK_PER_INSTANCE_SET */


#define BEGIN_PAD(VDEF_TYPE) \
RTOSBEGIN_PAD(VDEF_TYPE)

#define LOOP_LABEL \
RTOSLOOP_LABEL

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define LOOP_LABEL_PRD \
RTOSLOOP_LABEL_PRD

#define LOOP_LABEL_PRD_NOSTATE LOOP_LABEL_PRD

#else

#define LOOP_LABEL_PRD1 \
   XOS_TRACE_CALL \
   goto Label_Execute_Transition; \
   Label_New_Transition : \
     if (yVarP->CurrentInSaveQ != yVarP->SaveQ) { \
       xDiscardSignal(&yVarP->CurrentInSaveQ); \
     } \
     else \
       RTOSFREE_BUF(&(yVarP->yInSignalPtr)); \
   Label_New_Trans_PRD_No_Free: \
     yVarP->CurrentInSaveQ = yVarP->SaveQ; \
     if (yVarP->ActivePrd->RestartPRD != \
         yVarP->ActivePrd->NameNode->Assoc_Function) { \
       yVarP->ActivePrd->RestartPRD = yVarP->ActivePrd->NameNode->Assoc_Function; \
       return(0); \
     }
#define LOOP_LABEL_PRD2 \
   Label_Next_Saved : \
     yVarP->CurrentInSaveQ = yVarP->CurrentInSaveQ->Suc; \
     if (yVarP->CurrentInSaveQ != yVarP->SaveQ) { \
       yVarP->yInSignalPtr = (RTOSSIGNAL_DEF)yVarP->CurrentInSaveQ; \
       goto Label_Handle_Signal; \
     } \
   Label_Receive_Signal : \
     RTOSRECEIVEPRD(yVarP->yInSignalPtr,NULL,0,SDL_NULL) /* Last param by RST */
#define LOOP_LABEL_PRD3 \
   Label_Handle_Signal : \
     switch (xFindInputAction(INSIGNAL_NAME, (xPrsNode)yVarP)) { \
       case xNotInSignalSet : \
       case xDiscard :\
         /* discard signal */ \
         XOS_TRACE_DISCARD \
          if (yVarP->CurrentInSaveQ != yVarP->SaveQ) { \
           RTOSCALLSIGNALFREEFUNCSAVEQ(yVarP->CurrentInSaveQ); /* MAS */	\
           xDiscardSignal(&yVarP->CurrentInSaveQ); \
           goto Label_Next_Saved; \
         } \
         RTOSCALLSIGNALFREEFUNC(yVarP->yInSignalPtr); /* MAS */	 \
         RTOSFREE_BUF(&(yVarP->yInSignalPtr)); \
         goto Label_Receive_Signal; \
       case xSave : \
         /* save signal */ \
         XOS_TRACE_SAVE \
         if (yVarP->CurrentInSaveQ != yVarP->SaveQ) \
           goto Label_Next_Saved; \
         xSaveSignal (yVarP->SaveQ, yVarP->yInSignalPtr); \
         goto Label_Receive_Signal;
#define LOOP_LABEL_PRD4 \
       default :  /* xInput */ \
         if (yVarP->ActivePrd->RestartPRD == \
             yVarP->ActivePrd->NameNode->Assoc_Function) \
           goto Label_Execute_Transition; \
         if ((*yVarP->ActivePrd->RestartPRD)(VarP)) return(1); \
         goto Label_New_Trans_PRD_No_Free; \
     } \
   Label_Execute_Transition : \
     RTOSLABEL_EXECUTE_TRANSITION

#define LOOP_LABEL_PRD LOOP_LABEL_PRD1 LOOP_LABEL_PRD2 LOOP_LABEL_PRD3 LOOP_LABEL_PRD4
/*
#define LOOP_LABEL_PRD_NOSTATE \
   XOS_TRACE_CALL
*/
#define LOOP_LABEL_PRD_NOSTATE LOOP_LABEL_PRD
#endif
   /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define BEGIN_START_TRANSITION(STARTUP_PAR_TYPE) \
   yVarP->Parent = RTOSSENDER

#define CALL_SUPER_PAD_START(PAD) \
   yVarP->RestartPAD = PAD; \
   RTOSCALLSUPER_PAD(PAD) \
   goto Label_New_Transition_No_Free;

#define CALL_SUPER_PRD_START(PRD, THISPRD) \
   yVarP->ActivePrd->RestartPRD = PRD; \
   return PRD(VarP, yInstanceSetVars);

#else
#ifdef XOPTSIGNALALLOC
#define BEGIN_START_TRANSITION(STARTUP_PAR_TYPE) \
   yVarP->Parent = RTOSSENDER \
   yVarP->PrsNode = ((STARTUP_PAR_TYPE *)yVarP->yInSignalPtr)->PrsNode; \
   yVarP->PrsNode->VarP = VarP;
#else
#define BEGIN_START_TRANSITION(STARTUP_PAR_TYPE) \
   yVarP->Parent = RTOSSENDER \
   yVarP->PrsNode = ((STARTUP_PAR_TYPE *)ySVarP)->PrsNode; \
   yVarP->PrsNode->VarP = VarP;
#endif

#define CALL_SUPER_PAD_START(PAD) \
   yVarP->RestartPAD = PAD; \
   PAD(yVarP); \
   goto Label_New_Transition_No_Free;

#define CALL_SUPER_PRD_START(PRD, THISPRD) \
   yVarP->ActivePrd->RestartPRD = PRD; \
   if (PRD(VarP)) return(1); \
   goto Label_New_Trans_PRD_No_Free;
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define SIGNAL_NAME(SIG_NAME, SIG_IDNODE)           SIG_NAME

#define START_STATE                                 0
#define START_STATE_PRD                             0
#define XRPC_WAIT_STATE                             -1



/* ------------------ Actions within transitions ----------------- */


/* ---------------------------- Output --------------------------- */

/*
#define XSIGNALHEADERTYPE xEmptySignalStruct
#define XSIGNALHEADERTYPE SIGSELECT
*/

#define ALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   RTOSALLOC_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   RTOSALLOC_SIGNAL_PAR(SIG_NAME,SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)


#define TRANSFER_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   ERROR__TRANSFER_not_yet_implemented;
#define TRANSFER_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
   ERROR__TRANSFER_not_yet_implemented;

#define SIGNAL_ALLOC_ERROR
#define SIGNAL_ALLOC_ERROR_END

/*---+--------------------------------------------------------------
     Signal priority (fab)
     Adding priority information to signals before sending them
-------------------------------------------------------------------*/

#ifdef X_SIGNAL_PRIO
#define X_ASSIGN_PRIORITY(SignalPtr,P) SignalPtr->Priority = P;
#else
#define X_ASSIGN_PRIORITY(SignalPtr,P)
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   xHandle_Sig(yOutputSignalPtr,SDL_SELF,SIG_PAR_SIZE,RECEIVER,(RTOSTASK_TYPE)RECEIVER->NameNode->PROCID RTOSHANDLESIG_PAR);
#else
#define SDL_2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   RTOSSEND(&yOutputSignalPtr, RECEIVER,SIG_PAR_SIZE)
#endif


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#ifdef XMSC_TRACE
#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
{ SDL_PId tmpPId; \
   tmpPId = xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA); \
   XMSC_TRACE_OUTPUT(tmpPId, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   xHandle_Sig(yOutputSignalPtr,SDL_SELF,SIG_PAR_SIZE,tmpPId,(RTOSTASK_TYPE)tmpPId->NameNode->PROCID RTOSHANDLESIG_PAR); \
}
#else
#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
{ SDL_PId tmpPId; \
   tmpPId = xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA); \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   xHandle_Sig(yOutputSignalPtr,SDL_SELF,SIG_PAR_SIZE,tmpPId,(RTOSTASK_TYPE)tmpPId->NameNode->PROCID RTOSHANDLESIG_PAR); \
}
#endif

#else

#ifdef XMSC_TRACE
#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
{ SDL_PId tmpPId; \
   tmpPId = xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA); \
   XMSC_TRACE_OUTPUT(tmpPId, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   RTOSSEND(&yOutputSignalPtr, xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA), \
            SIG_PAR_SIZE) \
}
#else
#define SDL_2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   RTOSSEND(&yOutputSignalPtr, xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA), \
            SIG_PAR_SIZE)
#endif

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define SDL_2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   xHandle_Sig(yOutputSignalPtr,SDL_SELF,SIG_PAR_SIZE, RECEIVER,(RTOSTASK_TYPE)RECEIVER->NameNode->PROCID RTOSHANDLESIG_PAR);
#else
#define SDL_2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   RTOSSEND(&yOutputSignalPtr, RECEIVER,SIG_PAR_SIZE)
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#define SDL_ALT2OUTPUT(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   To be implemented;

#define SDL_ALT2OUTPUT_NO_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   To be implemented;

#define SDL_ALT2OUTPUT_COMPUTED_TO(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   To be implemented;

#define SDL_THIS                SDL_SELF

#define TO_PROCESS(PROC_NAME, PROC_IDNODE) \
   xTo_Process(PROC_IDNODE)


/* ----------------------------- RPC ----------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
/* Output of pCALL signal */
#define SDL_2OUTPUT_RPC_CALL(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
{  SDL_PId tmpPId; \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
   tmpPId = xRPCReceiver(RECEIVER, SIG_NAME, yVarP->PrsNode, VIA); \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   xHandle_Sig(yOutputSignalPtr,SDL_SELF,SIG_PAR_SIZE, tmpPId,(RTOSTASK_TYPE)tmpPId->NameNode->PROCID RTOSHANDLESIG_PAR); \
}

#else

#define SDL_2OUTPUT_RPC_CALL(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
{  SDL_PId tmpPId; \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, yOutputSignalPtr, SIG_NAME_STRING) \
/* ****** Find receiver when output contained no TO clause ****** */ \
   X_ASSIGN_PRIORITY(yOutputSignalPtr,PRIO) \
   if ( xEq_SDL_PId(RECEIVER, SDL_NULL) ) { \
     tmpPId = xFindReceiver(SIG_NAME, yVarP->PrsNode, VIA); \
     RTOSSEND(&yOutputSignalPtr, tmpPId,SIG_PAR_SIZE) \
   } \
   else { \
   RTOSSEND(&yOutputSignalPtr, RECEIVER,SIG_PAR_SIZE) \
   } \
}

#endif

/* Output of pREPLY signal */
#define XRPC_SAVE_SENDER 
#define XRPC_SENDER_IN_ALLOC   Not_Used
#define XRPC_SENDER_IN_OUTPUT  SenderRPCCall
#define XRPC_SAVE_SENDER_PRD
#define XRPC_SENDER_IN_ALLOC_PRD   Not_Used
#define XRPC_SENDER_IN_OUTPUT_PRD  SenderRPCCall

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define ALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#else

#define ALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PRD(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)

#define ALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE) \
RTOSALLOC_REPLY_SIGNAL_PRD_PAR(SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_TYPE)
#endif


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_2OUTPUT_RPC_REPLY(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, pREPLY_Signal, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(pREPLY_Signal,PRIO) \
   xHandle_Sig(pREPLY_Signal,SDL_SELF,SIG_PAR_SIZE,RECEIVER,(RTOSTASK_TYPE)RECEIVER->NameNode->PROCID RTOSHANDLESIG_PAR);

#define SDL_2OUTPUT_RPC_REPLY_PRD(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, pREPLY_Signal, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(pREPLY_Signal,PRIO) \
   xHandle_Sig(pREPLY_Signal,SDL_SELF,SIG_PAR_SIZE,RECEIVER,(RTOSTASK_TYPE)RECEIVER->NameNode->PROCID RTOSHANDLESIG_PAR);

#define SDL_RPCWAIT_NEXTSTATE(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yVarP->StateAfterRPC = CURRENT_STATE; \
   CURRENT_STATE = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yVarP->RestartAddress = RESTARTADDR; \
   goto Label_New_Transition;

#define SDL_RPCWAIT_NEXTSTATE_PRD(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yPrdVarP->StateAfterRPC = CURRENT_STATE_PRD; \
   CURRENT_STATE_PRD = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yPrdVarP->RestartAddress = RESTARTADDR; \
   return(0);

#define SDL_RPCWAIT_NEXTSTATE_XPT(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yVarP->StateAfterRPC = CURRENT_STATE; \
   CURRENT_STATE = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yVarP->RestartAddress = RESTARTADDR; \
   return;


#else

#define SDL_2OUTPUT_RPC_REPLY(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, pREPLY_Signal, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(pREPLY_Signal,PRIO) \
   RTOSSEND(&pREPLY_Signal, RECEIVER,SIG_PAR_SIZE)

#define SDL_2OUTPUT_RPC_REPLY_PRD(PRIO, VIA, SIG_NAME, SIG_IDNODE, RECEIVER, SIG_PAR_SIZE, SIG_NAME_STRING) \
   XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XMSC_TRACE_OUTPUT(RECEIVER, pREPLY_Signal, SIG_NAME_STRING) \
   X_ASSIGN_PRIORITY(pREPLY_Signal,PRIO) \
   RTOSSEND(&pREPLY_Signal, RECEIVER,SIG_PAR_SIZE)

#define SDL_RPCWAIT_NEXTSTATE(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yVarP->StateAfterRPC = CURRENT_STATE; \
   CURRENT_STATE = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yVarP->RestartAddress = RESTARTADDR; \
   goto Label_New_Transition;

#define SDL_RPCWAIT_NEXTSTATE_PRD(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yPrdVarP->StateAfterRPC = CURRENT_STATE_PRD; \
   CURRENT_STATE_PRD = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yPrdVarP->RestartAddress = RESTARTADDR; \
   goto Label_New_Transition;

#define SDL_RPCWAIT_NEXTSTATE_XPT(PREPLY_IDNODE, PREPLY_NAME, RESTARTADDR) \
   XOS_TRACE_NEXTSTATE("RPC Wait state") \
   XMSC_TRACE_NEXTSTATE("RPC_Wait_state") \
   yVarP->StateAfterRPC = CURRENT_STATE; \
   CURRENT_STATE = XRPC_WAIT_STATE; \
   yVarP->pREPLY_Waited_For = PREPLY_NAME; \
   yVarP->RestartAddress = RESTARTADDR; \
   return;

#endif

#define XGETEXPORTINGPRS(REMOTENODE) \
   xGetExportingPrs(REMOTENODE, yVarP->PrsNode)

#define XRPC_REPLY_INPUT
#define XRPC_REPLY_INPUT_PRD


/* ---------------------------- IMPORT --------------------------- */

#define XGETEXPORTADDR(REMOTENODE, EXPORTER, IS_DEF_EXPORTER) \
  xGetExportAddr(REMOTENODE, EXPORTER, IS_DEF_EXPORTER,(xPrsNode) yVarP)


/* ---------------------------- Create --------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define ALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE)

#define ALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE)

#else

#define ALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
RTOSALLOC_STARTUP(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE)

#define ALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE) \
RTOSALLOC_STARTUP_PAR(PROC_NAME, STARTUP_IDNODE, STARTUP_PAR_TYPE)

#endif

#define ALLOC_STARTUP_THIS \
   Create THIS not implemented;

#define STARTUP_ALLOC_ERROR
#define STARTUP_ALLOC_ERROR_END

/*
#define STARTUP_DATA_PTR \
   &yOutputSignalPtr->xParameters
*/


#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING)

#else

#define SDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING) \
RTOSSDL_CREATE(PROC_NAME, PROC_IDNODE, PROC_NAME_STRING)

#endif

#define SDL_CREATE_THIS \
   Create THIS not implemented;

/* --------------------- Transition functions -------------------- */
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XPTFUNC(PROC_NAME)      static int PROC_NAME (xPrsNode VarP, xPrsInstanceSetVars *yInstanceSetVars)
#define XPTCALL(PROC_NAME) \
if ( PROC_NAME ((xPrsNode)yVarP,yInstanceSetVars) == 1 ) \
  goto Label_Join_Transition; \
else \
  goto Label_New_Transition;
#else

#define XPTFUNC(PROC_NAME)      static int PROC_NAME (xPrsNode VarP)
#define XPTCALL(PROC_NAME) \
if ( PROC_NAME ((xPrsNode)yVarP) == 1 ) \
  goto Label_Join_Transition; \
else \
  goto Label_New_Transition;
#endif

/* ------------------------- Static Create ------------------------ */

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  LastUsedPId = (xEPrsNode)0; \
  printf("\n\nSystem startup\n\n");
#endif

#ifdef XMSC_TRACE
#define BEGIN_YINIT \
  xInitTimer();
#endif

#if (!defined XOS_TRACE) && (!defined XMSC_TRACE)  /* Needed for Borland compiler */
#define BEGIN_YINIT \
  xInitTimer();
#endif

#ifdef XENV
#define XCREATE_ENV_PROCESS \
RTOSXCREATE_ENV_PROCESS \
  XMSC_TRACE_STATIC_CREATE( xEnvPId, "Environment")
#else
#define XCREATE_ENV_PROCESS \
RTOSXCREATE_ENV_PROCESS \
  XMSC_TRACE_STATIC_CREATE( xEnvPrs, "Environment")
#endif

#else
/*

#ifdef XOS_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  SDL_NULL = current_process(); \
  LastUsedPId = SDL_NULL;
#elif XMSC_TRACE
#define BEGIN_YINIT \
  xInitTimer(); \
  SDL_NULL = current_process(); \
  XMSC_TRACE_START()
#else
#define BEGIN_YINIT \
  xInitTimer();
#endif
*/

#ifdef XENV
#define XCREATE_ENV_PROCESS \
RTOSXCREATE_ENV_PROCESS \
  XMSC_TRACE_STATIC_CREATE( xEnvPId, "Environment")
#else
#define XCREATE_ENV_PROCESS \
RTOSXCREATE_ENV_PROCESS \
  XMSC_TRACE_STATIC_CREATE( xEnvPId, "Environment")
#endif

#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define INIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE,PROC_NAME_STRING,MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION) \
  RTOSINIT_PROCESS_TYPE(PROC_NAME,PREFIX_PROC_NAME, PROC_IDNODE, \
  PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION)

#else

#define INIT_PROCESS_TYPE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, MAX_NO_OF_INST, STATIC_INST, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION)
#endif

#ifdef X_ONE_TASK_PER_INSTANCE_SET

#define SDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE,PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, \
PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, \
PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER)

#else

#define SDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE, PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, PAD_FUNCTION, BLOCK_INST_NUMBER) \
RTOSSDL_STATIC_CREATE(PROC_NAME, PREFIX_PROC_NAME, PROC_IDNODE,  \
  PROC_NAME_STRING, STARTUP_IDNODE, STARTUP_PAR_TYPE, PRIV_DATA_TYPE, PRIO, \
  PAD_FUNCTION, BLOCK_INST_NUMBER)
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */




/* ----------------------------- Stop ---------------------------- */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_STOP1 \
   XOS_TRACE_STOP \
   XMSC_TRACE_STOP \
   if (yInstanceSetVars->CurrentInSaveQ != yInstanceSetVars->SaveQ) { \
     xDiscardSignal(&yInstanceSetVars->CurrentInSaveQ); \
   } \
   else \
     RTOSFREE_BUF((void*)(&(yInstanceSetVars->yInSignalPtr))); \
RTOSEMPTYQUEUE(yInstanceSetVars->yInSignalPtr) 
#define SDL_STOP2 \
RTOSSDL_STOPREMOVETIMERS
#define SDL_STOP SDL_STOP1 SDL_STOP2 

#define SDL_STOP_XPT SDL_STOP1 RTOSSDL_STOPREMOVETIMERS_XPT

#else

#define SDL_STOP \
   XOS_TRACE_STOP \
   XMSC_TRACE_STOP \
   if (yVarP->CurrentInSaveQ != yVarP->SaveQ) { \
     xDiscardSignal(&(yVarP->CurrentInSaveQ)); \
   } \
   else \
     RTOSFREE_BUF(&(yVarP->yInSignalPtr)); \
RTOSEMPTYQUEUE(yVarP->yInSignalPtr) \
   xKillSaveQ(yVarP->SaveQ); \
   /* Reset all timers */ \
RTOSSDL_STOPREMOVETIMERS \
   xFreePrs(&yVarP->PrsNode); \
RTOSKILL_PROC

#define SDL_STOP_XPT SDL_STOP
#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */



/* ---------------------------- Timers --------------------------- */

/* Set without parameters */
#ifdef X_ONE_TASK_PER_INSTANCE_SET

#ifdef XOPTSIGNALALLOC
#define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yInstanceSetVars->SaveQ, TIMER_NAME_STRING); \
  RTOSALLOC_TIMER_SIGNAL (TIMER_NAME ,DUR_EXPR, TIMER_IDNODE) \
  XMSC_TRACE_SET( yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  xHandle_Timer(yOutputSignalPtr,DUR_EXPR,SDL_SELF);
  
#else
#define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yInstanceSetVars->SaveQ, TIMER_NAME_STRING); \
  RTOSALLOC_TIMER_SIGNAL (TIMER_NAME ,DUR_EXPR) \
  XMSC_TRACE_SET( yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  xHandle_Timer(yOutputSignalPtr,DUR_EXPR,SDL_SELF);

#endif

#else

#ifdef XOPTSIGNALALLOC
#define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yVarP->SaveQ, TIMER_NAME_STRING); \
  RTOSALLOC_TIMER_SIGNAL (TIMER_NAME,DUR_EXPR,TIMER_IDNODE) \
  XMSC_TRACE_SET( yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  xHandle_Timer(yOutputSignalPtr, DUR_EXPR, SDL_SELF);

#else
#define SDL_SET_DUR(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_SET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yVarP->SaveQ, TIMER_NAME_STRING); \
  RTOSALLOC_TIMER_SIGNAL (TIMER_NAME,DUR_EXPR) \
  XMSC_TRACE_SET( yOutputSignalPtr, TIMER_NAME_STRING, DUR_EXPR) \
  xHandle_Timer(yOutputSignalPtr, DUR_EXPR, SDL_SELF);

#endif

#endif


#define SDL_SET_TICKS(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  ERROR__Ticks_not_implemented;

#define SDL_SET(TIME_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  ERROR__Timers_not_implemented;

/* Set with parameters */
#define ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE) \
  RTOS_ALLOC_TIMER_SIGNAL_PAR(TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE)

#define TIMER_SIGNAL_ALLOC_ERROR
#define TIMER_SIGNAL_ALLOC_ERROR_END

/*
#define TIMER_DATA_PTR
*/
 

#define SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  RTOS_SDL_SET_DUR_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING)

#define SDL_SET_TICKS_WITH_PARA(TIME_EXPR, DUR_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  ERROR__Ticks_with_parameters_not_implemented;

#define SDL_SET_WITH_PARA(TIME_EXPR, TIMER_NAME, TIMER_IDNODE, TIMER_PAR_TYPE, EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  ERROR__Timers_with_parameters_not_implemented;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
/* Reset without parameters */
#define SDL_RESET(TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yInstanceSetVars->SaveQ, TIMER_NAME_STRING);


/* Active (timer active) */
#define SDL_ACTIVE(TIMER_NAME, TIMER_IDNODE, TIMER_VAR) \
   xSDLActive( TIMER_NAME,SDL_SELF, yInstanceSetVars->SaveQ, yInstanceSetVars->CurrentInSaveQ)
#else
#define SDL_RESET(TIMER_NAME, TIMER_IDNODE, TIMER_VAR, TIMER_NAME_STRING) \
  XOS_TRACE_RESET(TIMER_NAME_STRING) \
  XSDLRESET( TIMER_NAME, yVarP->SaveQ, TIMER_NAME_STRING);

/* Active (timer active) */
#define SDL_ACTIVE(TIMER_NAME, TIMER_IDNODE, TIMER_VAR) \
   xSDLActive( TIMER_NAME, SDL_SELF,yVarP->SaveQ, yVarP->CurrentInSaveQ)
#endif

/* Reset with parameters */
#define SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) \
  RTOS_SDL_RESET_WITH_PARA(EQ_FUNC, TIMER_VAR, TIMER_NAME_STRING) 


/* Timer variables */
#define DEF_TIMER_VAR(NAME)
#define INIT_TIMER_VAR(NAME) 
#define RELEASE_TIMER_VAR(NAME)
#define INPUT_TIMER_VAR(NAME) 

#define DEF_TIMER_VAR_PARA(TIMER_VAR) int TIMER_VAR;
#define INIT_TIMER_VAR_PARA(TIMER_VAR)
#define INPUT_TIMER_VAR_PARA(TIMER_VAR)
#define RELEASE_TIMER_VAR_PARA(TIMER_VAR)

/* NOW */
#define SDL_NOW SDL_Clock()


/* ------------------------ Procedure call ----------------------- */

#define ALLOC_PROCEDURE(PROC_NAME, PROC_IDNODE, VAR_SIZE) \
   yTempPrd = xGetPrd(PROC_IDNODE);
#define ALLOC_VIRT_PROCEDURE(PROC_IDNODE) \
   yTempPrd = xGetPrd(PROC_IDNODE);
#define ALLOC_THIS_PROCEDURE \
   yTempPrd = xGetPrd(yVarP->ActivePrd->NameNode);
#define PROCEDURE_ALLOC_ERROR
#define PROCEDURE_ALLOC_ERROR_END
#define PROC_DATA_PTR \
   yTempPrd

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define CALL_PROCEDURE(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if (PROC_NAME ((xPrsNode)yVarP, yInstanceSetVars )) goto Label_New_Transition;
#define CALL_PROCEDURE_IN_PRD(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if (PROC_NAME ((xPrsNode)yVarP, yInstanceSetVars)) return(1); /* MAS TST */

#define CALL_COMPSTMT_IN_COMPSTMT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   { int i; \
     xAddPrdCall(yTempPrd, VarP, LEVELS, RESTARTADDR); \
     i = PROC_NAME(VarP,  yInstanceSetVars); \
     if (i == 1) return 1; \
     if (i < 0) { SDL_BREAK(i+1) } \
   }

#define CALL_PROCEDURE_XPT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( PROC_NAME ((xPrsNode)yVarP, yInstanceSetVars ) ) \
       return;

#define CALL_VIRT_PROCEDURE(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ((*PROC_IDNODE->Assoc_Function)((xPrsNode)yVarP, yInstanceSetVars)) goto Label_New_Transition;

#define CALL_VIRT_PROCEDURE_IN_PRD(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ((*PROC_IDNODE->Assoc_Function)((xPrsNode)yVarP, yInstanceSetVars)) return(1); /* MAS */

#define CALL_VIRT_PROCEDURE_XPT(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, LEVELS, RESTARTADDR); \
   if ( (*PROC_IDNODE->Assoc_Function)((xPrsNode)yVarP, yInstanceSetVars)) ) \
      goto Label_New_Transition; 

#define CALL_THIS_PROCEDURE(RESTARTADDR) \
   xAddPrdCall(yTempPrd, (xPrsNode)yVarP, 1, RESTARTADDR); \
   if (!(yVarP->ActivePrd->NameNode->Assoc_Function)((xPrsNode)yVarP, yInstanceSetVars)) \
       return(0) ;
       
#define SDL_RETURN \
   XOS_TRACE_RETURN \
   xReleasePrd(VarP); \
   return(0);    
#define SDL_BREAK(LEVELS) \
   xReleasePrd(VarP); \
   return LEVELS;
       
       
#else	/*X_ONE_TASK_PER_INSTANCE_SET*/

#define CALL_PROCEDURE(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   PROC_NAME (VarP);

#define CALL_PROCEDURE_IN_PRD(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   PROC_NAME (VarP);

#define CALL_COMPSTMT_IN_COMPSTMT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   { int i; \
     xAddPrdCall(yTempPrd, VarP, LEVELS); \
     i = PROC_NAME(VarP); \
     if (i == 1) return 1; \
     if (i < 0) { SDL_BREAK(i+1) } \
   }


#define CALL_PROCEDURE_XPT(PROC_NAME, PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   PROC_NAME (VarP);

#define CALL_VIRT_PROCEDURE(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   (*PROC_IDNODE->Assoc_Function)(VarP);

#define CALL_VIRT_PROCEDURE_IN_PRD(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   (*PROC_IDNODE->Assoc_Function)(VarP);

#define CALL_VIRT_PROCEDURE_XPT(PROC_IDNODE, LEVELS, RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, LEVELS); \
   (*PROC_IDNODE->Assoc_Function)(VarP) ;

#define CALL_THIS_PROCEDURE(RESTARTADDR) \
   xAddPrdCall(yTempPrd, VarP, 1); \
   (yVarP->ActivePrd->NameNode->Assoc_Function)(VarP);

#define SDL_RETURN \
   XOS_TRACE_RETURN \
   xReleasePrd(VarP); \
   return(1);    
#define SDL_BREAK(LEVELS) \
   xReleasePrd(VarP); \
   return LEVELS;


#endif

#define CALL_PROCEDURE_STARTUP


/* ----------------------- Procedure return ---------------------- */



/* --------------------------- Nextstate ------------------------- */

#define SDL_NEXTSTATE(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   CURRENT_STATE = STATE_IDNODE; \
   goto Label_New_Transition;

#define SDL_DASH_NEXTSTATE \
   XOS_TRACE_DASH_NEXTSTATE \
   goto Label_New_Transition;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define SDL_NEXTSTATE_PRD(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   CURRENT_STATE_PRD = STATE_IDNODE; \
   return(1); /* SC1000388/tsr */

#define SDL_NEXTSTATE_XPT(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   CURRENT_STATE = STATE_IDNODE; \
   return;

#define SDL_DASH_NEXTSTATE_XPT \
   XOS_TRACE_DASH_NEXTSTATE \
   return;

#define SDL_DASH_NEXTSTATE_PRD \
   XOS_TRACE_DASH_NEXTSTATE \
   return(1); /* MAS */
#else
#define SDL_NEXTSTATE_PRD(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   CURRENT_STATE_PRD = STATE_IDNODE; \
   goto Label_New_Transition;

#define SDL_NEXTSTATE_XPT(STATE_NAME, STATE_IDNODE, STATE_NAME_STRING) \
   XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   CURRENT_STATE = STATE_IDNODE; \
   return;

#define SDL_DASH_NEXTSTATE_XPT \
   XOS_TRACE_DASH_NEXTSTATE \
   return;

#define SDL_DASH_NEXTSTATE_PRD \
   XOS_TRACE_DASH_NEXTSTATE \
   goto Label_New_Transition;
#endif


/* ----------------------------- Join ---------------------------- */
#define XJOIN_XPT(RESTARTADDR) \
   yVarP->RestartAddress = RESTARTADDR; \
   return;

#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XJOIN_SUPER_PRS(RESTARTADDR,RESTARTPAD) \
   yVarP->RestartAddress = RESTARTADDR; \
   yVarP->RestartPAD = RESTARTPAD; \
/*   RESTARTPAD(yVarP,InputPortQ,yInstanceSetVars); */ \
   RTOSCALLSUPER_PAD(RESTARTPAD) \
   goto Label_New_Transition;

#define XJOIN_SUPER_PRD(RESTARTADDR,RESTARTPRD) \
   yPrdVarP->RestartAddress = RESTARTADDR; \
   yPrdVarP->RestartPRD = RESTARTPRD; \
   return RESTARTPRD(yVarP,yInstanceSetVars);

#else
#define XJOIN_SUPER_PRS(RESTARTADDR,RESTARTPAD) \
   yVarP->RestartAddress = RESTARTADDR; \
   yVarP->RestartPAD = RESTARTPAD; \
   RESTARTPAD(yVarP); \
   goto Label_New_Transition;

#define XJOIN_SUPER_PRD(RESTARTADDR,RESTARTPRD) \
   yPrdVarP->RestartAddress = RESTARTADDR; \
   yPrdVarP->RestartPRD = RESTARTPRD; \
   return RESTARTPRD(yVarP);

#endif

/* --------------------------- Decision -------------------------- */

/* Informal decisions */
#define BEGIN_INFORMAL_DECISION(NO_OF_PATHS, QUESTION) \
   Informal_Decision_not_implemented
#define DEF_INFORMAL_PATH(PATH_NO, ANSWER, SYMBOLNUMBER)
#define DEF_INFORMAL_ELSE_PATH(PATH_NO, SYMBOLNUMBER)
#define END_DEFS_INFORMAL_PATH(NO_OF_PATHS)
#define BEGIN_FIRST_INFORMAL_PATH(PATH_NO)
#define BEGIN_INFORMAL_PATH(PATH_NO)
#define END_INFORMAL_PATH
#define BEGIN_INFORMAL_ELSE_PATH(PATH_NO)
#define END_INFORMAL_ELSE_PATH
#define END_INFORMAL_DECISION

/* Non-deterministic decisions */
#define BEGIN_ANY_DECISION(NO_OF_PATHS) \
  ANY_Decision_not_implemented
#define DEF_ANY_PATH(PATH_NO, SYMBOLNUMBER)
#define END_DEFS_ANY_PATH(NO_OF_PATHS)
#define BEGIN_FIRST_ANY_PATH(PATH_NO)
#define BEGIN_ANY_PATH(PATH_NO)
#define END_ANY_PATH
#define END_ANY_DECISION


/* ----------------------------- View ---------------------------- */

#define SDL_VIEW(PID_EXPR, HAS_EXPR, VAR_NAME_STRING, REVEALED_LIST, SORT_SIZE) \
   SDL_View(REVEALED_LIST, PID_EXPR, HAS_EXPR, (xPrsNode)yVarP, xeView(VAR_NAME_STRING) SORT_SIZE)


/* ------------------------ Execution trace ---------------------- */

#define XCHECK_UNION_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   } /* 3.1 */
#define XCHECK_UNION_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   } /* 3.1 */
#define XCHECK_UNION_TAG_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) /* 3.1 */

#define XCHECK_OPTIONAL_USAGE(PRESENT_VAR,COMPNAME) /* 3.1 */

#define XSET_CHOICE_TAG(TAG,VALUE,ASSTAG,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   } /* 3.1 */
#define XSET_CHOICE_TAG_FREE(TAG,VALUE,ASSTAG,NEQTAG,FREEFUNC,COMPNAME,CURR_VALUE,TYPEINFO) \
   if (NEQTAG(TAG,VALUE)) { \
     FREEFUNC((void **)&(TAG)); \
     ASSTAG(TAG,VALUE,XASS_MR_ASS_NF); \
   } /* 3.1 */
#define XCHECK_CHOICE_USAGE(TAG,VALUE,NEQTAG,COMPNAME,CURR_VALUE,TYPEINFO) /* 3.1 */

#define XCHECK_OREF(VALUE,REF_TYPEINFO,REF_SORT)
#define XCHECK_OREF2(VALUE)
#define XCHECK_OWN(VALUE,REF_TYPEINFO,REF_SORT)

#define XCHECK_REF(VALUE,SORTIDNODE,REF_SORT)

#ifdef XMSC_TRACE
extern int SignalId;

#ifdef XMSC_EDITOR
#define XMSC_TRACE_START()
#else
#define XMSC_TRACE_START() \
   XMSC_FPRINT(("%s\n", "msc RTOS_Trace;"))
#endif
#define XMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   RTOSXMSC_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING)
#define XMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING) \
   RTOSXMSC_TRACE_CREATE( INSTANCE, PROC_NAME_STRING)
#define XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   RTOSXMSC_TRACE_NEXTSTATE(STATE_NAME_STRING)

#else
#define XMSC_TRACE_START()
#define XMSC_TRACE_CREATE(INSTANCE, PROC_NAME_STRING)
#define XMSC_TRACE_STATIC_CREATE( INSTANCE, PROC_NAME_STRING)
#define XMSC_TRACE_NEXTSTATE(STATE_NAME_STRING)
#define XMSC_TRACE_INPUT(SIG_NAME_STRING)
#define XMSC_TRACE_OUTPUT(RECEIVER, SIGNAL, SIG_NAME_STRING)
#define XMSC_TRACE_STOP 
#define XMSC_TRACE_SET( TIMER, TIMER_NAME_STRING, DUR_EXPR)
#define XMSC_TRACE_RESET( TIMER_ID, TIMER_NAME_STRING)
#endif



#ifdef XOS_TRACE
extern SDL_PId LastUsedPId;
/* YPRSNAME_VAR, YPRDNAME_VAR, and XOS_TRACE_INPUT in generated code,
   all other macros only used in this file */

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern xEPrsNode LastUsedPId;
#define YPRSNAME_VAR(PRS_NAME_STRING) \
   char ProcName[] = PRS_NAME_STRING; \
   strcpy( yInstanceSetVars->name, ProcName);
#else
extern SDL_PId LastUsedPId;
#define YPRSNAME_VAR(PRS_NAME_STRING) \
   char ProcName[] = PRS_NAME_STRING; \
   strcpy( yVarP->ProcName, ProcName);
#endif

#define YPRDNAME_VAR(PRD_NAME_STRING) \
   char ProcName[] = PRD_NAME_STRING;

#define XOS_TRACE_OUTPUT(SIG_NAME_STRING) \
   XOS_FPRINT(("%s: signal %s sent\n", ProcName,SIG_NAME_STRING))
#define XOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING) \
   RTOSXOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING)
#define XOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING) \
   RTOSXOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING)

    
#define XOS_TRACE_STOP \
   XOS_FPRINT(("%s: stopped\n\n", ProcName))
#define XOS_TRACE_CALL {\
   if (yVarP->ActivePrd->RestartPRD == yVarP->ActivePrd->NameNode->Assoc_Function) \
     XOS_FPRINT(("%s: Called as procedure\n", ProcName)) \
  }
#define XOS_TRACE_RETURN \
   XOS_FPRINT(("%s: Performed return\n", ProcName))
#define XOS_TRACE_SET(TIMER_NAME_STRING) \
   XOS_FPRINT(("%s: Set timer %s\n", ProcName, TIMER_NAME_STRING))
#define XOS_TRACE_RESET(TIMER_NAME_STRING) \
   XOS_FPRINT(("%s: Reset timer %s\n", ProcName, TIMER_NAME_STRING))
#define XOS_TRACE_NEXTSTATE(STATE_NAME_STRING) \
   XOS_FPRINT(("%s: nextstate %s\n",ProcName,STATE_NAME_STRING))
#define XOS_TRACE_DASH_NEXTSTATE \
   XOS_FPRINT(("%s: dash nextstate\n", ProcName))
#define XOS_TRACE_INPUT(SIG_NAME_STRING) \
   XOS_FPRINT(("%s: input signal %s\n", ProcName,SIG_NAME_STRING))
#define XOS_TRACE_SAVE \
   XOS_FPRINT(("%s: Signal in last input trace saved\n", ProcName))
#define XOS_TRACE_SAVE_ENABLING_C \
   XOS_FPRINT(("%s: Signal in last input trace saved\n", ProcName))
#define XOS_TRACE_DISCARD \
   XOS_FPRINT(("%s: Signal in last input trace discarded\n", ProcName))
#define XOS_TRACE_SAVEADDR \
   XOS_FPRINTADDR(("Signal in last input trace saved\n"))
#define XOS_TRACE_DISCARDADDR \
   XOS_FPRINTADDR(("Signal in last input trace discarded\n"))

#define XOS_STATIC_FPRINT(PARAM) \
   printf PARAM; printf("\n");


#else
#define YPRSNAME_VAR(PRS_NAME_STRING)
#define YPRDNAME_VAR(PRD_NAME_STRING)
#define XOS_TRACE_OUTPUT(SIG_NAME_STRING)
#define XOS_TRACE_CREATE(INSTANCE, PROC_NAME_STRING)
#define XOS_TRACE_STATIC_CREATE(INSTANCE, PROC_NAME_STRING)
#define XOS_TRACE_STOP
#define XOS_TRACE_CALL
#define XOS_TRACE_RETURN
#define XOS_TRACE_SET(TIMER_NAME_STRING)
#define XOS_TRACE_RESET(TIMER_NAME_STRING)
#define XOS_TRACE_NEXTSTATE(STATE_NAME_STRING)
#define XOS_TRACE_DASH_NEXTSTATE
#ifdef XMSC_TRACE
#define XOS_TRACE_INPUT(SIG_NAME_STRING) XMSC_TRACE_INPUT(SIG_NAME_STRING)
#else
#define XOS_TRACE_INPUT(SIG_NAME_STRING)
#endif
#define XOS_TRACE_SAVE
#define XOS_TRACE_SAVE_ENABLING_C
#define XOS_TRACE_DISCARD
#define XOS_TRACE_SAVEADDR
#define XOS_TRACE_DISCARDADDR
#endif



#define XDEBUG_LABEL( AAA)
#ifdef XTORNADOINT
extern  int SignalId;
#define XAT_FIRST_SYMBOL(SYMB_NO) SignalId++;
#else
#define XAT_FIRST_SYMBOL(SYMB_NO) ;
#endif /* XTORNADOINT */
#define XBETWEEN_STMTS(SYMB_NO, C_LINE_NO)
#define XBETWEEN_STMTS_PRD(SYMB_NO, C_LINE_NO)
#define XBETWEEN_SYMBOLS(SYMB_NO, C_LINE_NO)
#define XBETWEEN_SYMBOLS_PRD(SYMB_NO, C_LINE_NO)
#define XAFTER_VALUE_RET_PRDCALL(SYMB_NO)
#define XAT_LAST_SYMBOL



/****+***************************************************************
     SDL Input  (freeing params in asterisk inputs)
********************************************************************/
#ifdef XFREESIGNALFUNCS
#ifdef X_ONE_TASK_PER_INSTANCE_SET
#define XRELEASE_SIGNAL_PARS \
    CallSignalFreeFunc( yInstanceSetVars->yInSignalPtr->SignalCode,  yInstanceSetVars->yInSignalPtr+1 );

#else  /*  X_ONE_TASK_PER_INSTANCE_SET */
#define XRELEASE_SIGNAL_PARS \
    CallSignalFreeFunc( yVarP->yInSignalPtr->SignalCode,  yVarP->yInSignalPtr+1 );
#endif   /* X_ONE_TASK_PER_INSTANCE_SET */
#endif   /* XFREESIGNALFUNCS */

/****+***************************************************************
     SDL Save
********************************************************************/

/****+***************************************************************
     SDL Timer
********************************************************************/

/****+***************************************************************
     sdl
********************************************************************/
extern void xHandle_Timer XPP((RTOSSIGNAL_DEF OutputSignal, SDL_Duration Dur_Expr, SDL_PId Sender));

extern SDL_Time SDL_Now XPP((void)); 

#ifdef X_ONE_TASK_PER_INSTANCE_SET


extern xbool xInputSignal (
  xPrsNode     *yVarP,
  xPrsInstanceSetVars *yInstanceSetVars,
  int           WhereToStart,
  SDL_PId       InputPortQ);


#else


extern xbool xInputSignal (xPrsNode *yVarP, int WhereToStart);


#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

#ifdef X_ONE_TASK_PER_INSTANCE_SET


extern void xHandle_Sig(RTOSSIGNAL_DEF OutputSignal,SDL_PId Sender,int SigPar_Size, 
SDL_PId Receiver, RTOSTASK_TYPE ReceiverTask RTOSHANDLEMESS_TYPE);


#endif
       /* X_ONE_TASK_PER_INSTANCE_SET */

/****+***************************************************************
     os
********************************************************************/

/****+***************************************************************
     Initialization functions
********************************************************************/

/*---+---------------------------------------------------------------
     System_Init_Func
-------------------------------------------------------------------*/

/****+***************************************************************
     Timer Procedures
********************************************************************/

/*---+---------------------------------------------------------------
     xSDLReset
-------------------------------------------------------------------*/

/*---+---------------------------------------------------------------
     xSDLActive
-------------------------------------------------------------------*/

/****+***************************************************************
     xEPrsNode handling
********************************************************************/

/*---+---------------------------------------------------------------
     xAllocPrsUseMyMemory
-------------------------------------------------------------------*/

/*---+---------------------------------------------------------------
     xAllocPrs
-------------------------------------------------------------------*/
extern xEPrsNode xAllocPrs  XPP(( xPrsIdNode  PType, SDL_PId PId ));

/*---+---------------------------------------------------------------
     xFreePrs
-------------------------------------------------------------------*/
extern void xFreePrs XPP(( xEPrsNode  *Prs )); 


/****+***************************************************************
     SDL Procedures
********************************************************************/

typedef struct xPrdStruct {
  PROCEDURE_VARS
}  xPrdRec;

extern xPrdNode xGetPrd  XPP((
  xPrdIdNode   PrdId ));

#ifdef X_ONE_TASK_PER_INSTANCE_SET
extern void xAddPrdCall  XPP((
  xPrdNode   R,
  xPrsNode   VarP,
  int        StaticFatherLevel,
  int        RestartAddress ));
#else
extern void xAddPrdCall  XPP((
  xPrdNode   R,
  xPrsNode   VarP,
  int        StaticFatherLevel ));
#endif

extern void xReleasePrd XPP(( xPrsNode  VarP )); 


/****+***************************************************************
     Structure nodes
********************************************************************/

typedef struct xEPrsStruct {
   xEPrsNode      NextPrs;
   SDL_PId        Self;
   xPrsIdNode     NameNode;
   int            BlockInstNumber;
   xPrsNode       VarP;
}  xEPrsRec;

typedef struct xPrsStruct {
  PROCESS_VARS
}  xPrsRec;

#define XPRSREC xEPrsRec

typedef enum {
  xRemoteVarEC,
  xRemotePrdEC,
  xSignalrouteEC,
  xStateEC,
  xTimerEC,
  xFormalParEC,
  xLiteralEC,
  xVariableEC,
  xBlocksubstEC,
  xPackageEC,
  xProcedureEC,
  xOperatorEC,
  xProcessEC,
  xProcessTypeEC,
  xGateEC,
  xSignalEC,
  xSignalParEC,
  xStartUpSignalEC,
  xRPCSignalEC,
  xSortEC,
  xSyntypeEC,
  xSystemEC,
  xSystemTypeEC,
  xBlockEC,
  xBlockTypeEC,
  xChannelEC,
  xServiceEC,
  xCompoundStmtEC,
  xSyntVariableEC,
  xServiceTypeEC,
  xMonitorCommandEC
  /* xExportEC */
  /* xViewEC */
  /* xChannelsubstEC */
  /* xEnvironmentEC */
  /* xConnectEC */
  /* xGeneratorEC */
  /* xImportedE */
  /* xLabelEC */
  /* xSignallistEC */
  /* xSynonymEC */
}   xEntityClassType;

typedef enum {
  xPredef, xUserdef, xEnum,
  xStruct, xArray, xGArray, xString,
  xPowerSet, xGPowerSet, xInherits, xSyntype,
  xUnion
}   xTypeOfSort;

typedef char  *xNameType;

                                  /*VIEW*/
typedef struct xViewListStruct {
   xPrsIdNode  ViewingPrs;
   xptrint     Offset;
}  xViewListRec;


typedef struct xIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
}  xIdRec;


                                  /*BLOCKSUBSTRUCTURE*/
typedef struct xBlockSubstIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
}  xBlockSubstIdRec;

typedef struct xViewIndexStruct {
   char              *ViewName;   /* var name, prefix for type */
   int               Index;       /* index in xViewListRec */
} xViewIndexRec;

                                  /*PACKAGE*/
typedef struct xPackageIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
#ifdef XIDNAMES
   xNameType         ModuleName;
#endif
}  xPackageIdRec;


                                  /*SYSTEM*/
typedef struct xSystemIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   xIdNode         * Contents;
   XCONST_COMP xPrdIdNode      * VirtPrdList;
   xSystemIdNode     Super;
#ifdef XTRACE
   int               Trace_Default;
#endif
#ifdef XGRTRACE
   int               GRTrace;
#endif
#ifdef XMSCE
   int               MSCETrace;
#endif
}  xSystemIdRec;


                                  /*CHANNEL,SIGNALROUTE*/
#ifndef XOPTCHAN
typedef struct xChannelIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   XSIGTYPE         *SignalSet; /*Array*/
   xIdNode          *ToId;      /*Array*/
   xChannelIdNode    Reverse;
}  xChannelIdRec;   /* And USignalRouteEC.*/
#endif


                                  /*BLOCK*/
typedef struct xBlockIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   xBlockIdNode      Super;
   xIdNode         * Contents;
   XCONST_COMP xPrdIdNode      * VirtPrdList;
   xViewListRec    * ViewList;
   xViewIndexRec  * ViewIndex;
   int               NumberOfInst;
#ifdef XTRACE
   int               Trace_Default;
#endif
#ifdef XGRTRACE
   int               GRTrace;
#endif
#ifdef XMSCE
   int               MSCETrace;
   int               GlobalInstanceId;
#endif
}  xBlockIdRec;


                                  /*PROCESS*/
typedef struct xPrsIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   xStateIdNode     *StateList;
   XSIGTYPE         *SignalSet; /*Used as an array of xIdNode.*/
#ifndef XNOUSEOFSERVICE
   XCONST_COMP xIdNode          *Contents;
#endif
#ifndef XOPTCHAN
   xIdNode          *ToId; /*Array*/
#endif
   int               MaxNoOfInst;
#ifdef XNRINST
   int               NextNr;
   int               NoOfStaticInst;
#endif
   xEPrsNode         *ActivePrsList;
   xptrint           VarSize;
#if defined(XPRSPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
   int               Prio;
#endif
   xEPrsNode         *AvailPrsList;
#ifdef XTRACE
   int               Trace_Default;
#endif
#ifdef XGRTRACE
   int               GRTrace;
#endif
#ifdef XBREAKBEFORE
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
   int               MaxSymbolNumber;
   int               SignalSetLength;
#endif
#ifdef XMSCE
   int               MSCETrace;
#endif
#ifdef XCOVERAGE
   long int         *CoverageArray;
   long int          NoOfStartTransitions;
   long int          MaxQueueLength;
#endif
#ifdef X_ONE_TASK_PER_INSTANCE_SET
RTOSXPRSIDCOMP1
#else
RTOSXPRSIDCOMP2
#endif
   void              (*Free_Vars) XPP((void *));
   xPrsIdNode        Super;
   XCONST_COMP xPrdIdNode      * VirtPrdList;
   xBlockIdNode      InBlockInst;
RTOSXPRSIDCOMP0
#ifdef X_ONE_TASK_PER_INSTANCE_SET
RTOSXPRSIDCOMP3
#endif
}  xPrsIdRec;

#ifndef XNOUSEOFSERVICE
                                  /*SERVICE*/
typedef struct xSrvIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;

#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   XCONST_COMP xStateIdNode     *StateList;
   XCONST_COMP xSignalIdNode    *SignalSet; /*Used as an array of xIdNode.*/
#ifndef XOPTCHAN
   XCONST_COMP xIdNode          *ToId; /*Array*/
#endif
   xptrint           VarSize;
#ifdef XBREAKBEFORE
#ifndef ULTRIXCC
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
#else
   char             *(*GRrefFunc) ();
#endif
   int               MaxSymbolNumber;
   int               SignalSetLength;
#endif
#ifdef XCOVERAGE
   long int         *CoverageArray;
   long int          NoOfStartTransitions;
#endif
   xSrvNode         *AvailSrvList;
   void              (*PAD_Function) XPP((xPrsNode));
   void              (*Free_Vars) XPP((void *));
   xSrvIdNode        Super;
   XCONST_COMP xPrdIdNode      * VirtPrdList;
}  xSrvIdRec;
#endif

                                  /*PROCEDURE*/
typedef struct xPrdIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   xStateIdNode     *StateList;
   XSIGTYPE         *SignalSet; /*Used as an array of xIdNode.*/
#ifdef X_ONE_TASK_PER_INSTANCE_SET
   xbool             (*Assoc_Function) XPP((void *, xPrsInstanceSetVars*));
#else
   xbool         (*Assoc_Function) XPP((void *));
#endif
   void              (*Free_Vars) XPP((void *));
   xptrint           VarSize;
   xPrdNode         *AvailPrdList;
#ifdef XBREAKBEFORE
   char             *(*GRrefFunc) XPP((int, xSymbolType *));
   int               MaxSymbolNumber;
   int               SignalSetLength;
#endif
#ifdef XCOVERAGE
   long int         *CoverageArray;
#endif
   xPrdIdNode        Super;
   XCONST_COMP xPrdIdNode      * VirtPrdList;
}  xPrdIdRec;


                                  /*REMOTE PROCEDURE*/
typedef struct xRemotePrdListStruct *xRemotePrdListNode;
typedef struct xRemotePrdListStruct {
   xRemotePrdListNode  Next;
   xPrsIdNode          ExportedPrs;
}  xRemotePrdListRec;

typedef struct xRemotePrdIdStruct {
   xEntityClassType    EC;
#ifdef XSYMBTLINK
   xIdNode             First;
   xIdNode             Suc;
#endif
   xIdNode             Parent;
#ifdef XIDNAMES
   xNameType           Name;
#endif
   xRemotePrdListNode  RemoteList;   
}  xRemotePrdIdRec;


#ifdef XOPTSIGNALALLOC
                                /* SIGNAL, TIMER */
typedef struct xSignalIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   xptrint           VarSize;
   xSignalHeader      *AvailSignalList;
#ifndef ULTRIXCC
   xbool             (*Equal_Timer) XPP((void *, void *));
#else
   xbool             (*Equal_Timer) ();
#endif
#ifdef XFREESIGNALFUNCS
#ifndef ULTRIXCC
   void              (*Free_Signal) XPP((void *));
#else
   void              (*Free_Signal) ();
#endif
#endif
#ifdef XBREAKBEFORE
   char               *RefToDefinition;
#endif
#if defined(XSIGPRIO) || defined(XSIGPRSPRIO) || defined(XPRSSIGPRIO)
   int               Prio;
#endif
#ifdef XCORBA
   void              (*Request_Function) XPP((xSignalNode));
#endif
}  xSignalIdRec;   /* And xTimerEC, xStartUpSignalEC, and xRPCSignalEC.*/

#endif
                                  /*STATE*/
typedef struct xStateIdStruct {
   xEntityClassType  EC;
#ifdef XSYMBTLINK
   xIdNode           First;
   xIdNode           Suc;
#endif
   xIdNode           Parent;
#ifdef XIDNAMES
   xNameType         Name;
#endif
   int               StateNumber;
   xInputAction     *SignalHandlArray;
                         /*Used as an array of xInputAction.*/
   XINPUTREFTYPE    *InputRef;
#ifndef ULTRIXCC
   xInputAction      (*EnablCond_Function) XPP((XSIGTYPE, void *));
#else
   xInputAction      (*EnablCond_Function) ();
#endif
   void              (*ContSig_Function) XPP((void *, int *, xIdNode *, int *));
   int               StateProperties;
#ifdef XCOVERAGE
   long int         *CoverageArray;
#endif
   xStateIdNode      Super;
}  xStateIdRec;


                                  /*REMOTE VAR*/
typedef struct xRemoteVarListStruct *xRemoteVarListNode;
typedef struct xRemoteVarListStruct {
   xRemoteVarListNode  Next;
   xPrsIdNode          ExportingPrs;
#ifndef XNOUSEOFSERVICE
   xSrvIdNode          SrvId;
#endif
   xptrint             Offset;
}  xRemoteVarListRec;

typedef struct xRemoteVarIdStruct {
   xEntityClassType     EC;
#ifdef XSYMBTLINK
   xIdNode              First;
   xIdNode              Suc;
#endif
   xIdNode              Parent;
#ifdef XIDNAMES
   xNameType            Name;
#endif
   xptrint              SortSize;
   xRemoteVarListNode   RemoteList;
}  xRemoteVarIdRec;





/*---+---------------------------------------------------------------
     xInsertIdNode
-------------------------------------------------------------------*/
#define xInsertIdNode(Node)

/*---+---------------------------------------------------------------
     xInsertExportedVar
-------------------------------------------------------------------*/
extern void xInsertExportedVar XPP((
  xRemoteVarListNode  ExportedVarNode,
  xRemoteVarIdNode    RemoteVarNode ));

/*---+---------------------------------------------------------------
     xInsertExportedPrd
-------------------------------------------------------------------*/
extern void xInsertExportedPrd XPP((
  xRemotePrdListNode  ExportedPrdNode,
  xRemotePrdIdNode    RemotePrdNode ));

/*---+---------------------------------------------------------------
     xGetExportAddr
-------------------------------------------------------------------*/
extern void * xGetExportAddr XPP((
  xRemoteVarIdNode RemoteVarNode,
  SDL_PId          P,
  xbool            IsDefP,
  xPrsNode         Importer ));

/*---+---------------------------------------------------------------
     xGetExportingPrs
-------------------------------------------------------------------*/
extern SDL_PId xGetExportingPrs XPP((
  xRemotePrdIdNode RemotePrdNode,
  xEPrsNode         Importer ));

/*---+---------------------------------------------------------------
     SDL_View
-------------------------------------------------------------------*/

extern void * SDL_View (
         xViewListRec *VList,       /* list of prs revealing this variable */
         SDL_PId       P,           /* PId expr in view */
         xbool         IsDefP,      /* is PId expression in view() */
         xPrsNode      ViewingPrs,  /* process instance perfoming view */
  xeView(char *        Reveal_Var)  /* viewed variable name as string */
         int           SortSize);   /* size of sort */



/*---+---------------------------------------------------------------
     xInList
-------------------------------------------------------------------*/ 
extern xbool xInList  XPP((
  XSIGTYPE   Id,
  XSIGTYPE  *IdList ));

/*---+---------------------------------------------------------------
     xContentsInstNode
-------------------------------------------------------------------*/
extern xIdNode xContentsInstNode XPP((
  xIdNode  CurrentInst,
  xIdNode  TypeToFindInstOf ));


/*---+---------------------------------------------------------------
     xPrsInst
-------------------------------------------------------------------*/
extern xPrsIdNode xPrsInst XPP((xIdNode, xIdNode, int));


/*---+---------------------------------------------------------------
     SDL_View_Index
-------------------------------------------------------------------*/
extern int SDL_View_Index XPP((xPrsNode, char *));


#ifndef XOPTCHAN
/*---+---------------------------------------------------------------
     xFindReceiver
-------------------------------------------------------------------*/
extern SDL_PId xFindReceiver XPP((
         XSIGTYPE    SignalId,
         xEPrsNode    SenderPrs,
         xIdNode    *ViaList ));
#endif

/*---+---------------------------------------------------------------
     xRPCReceiver
-------------------------------------------------------------------*/
extern SDL_PId xRPCReceiver XPP((
         SDL_PId     Receiver,
         XSIGTYPE    SignalId,
         xEPrsNode   SenderPrs,
         xIdNode    *ViaList ));

/*---+---------------------------------------------------------------
     xFindInputAction
-------------------------------------------------------------------*/
extern xInputAction xFindInputAction XPP((
  XSIGTYPE  SignalId,
  xPrsNode  VarP));

/*---+---------------------------------------------------------------
     env
-------------------------------------------------------------------*/
RTOSRTOSPAD_HEAD;

/****+***************************************************************
     SDL PId
********************************************************************/

extern xPrsIdNode   xEnvId;
extern xEPrsNode    xEnvPrs;
extern XCONST struct xStateIdStruct  xStartStateIdRec;
extern xIdNode      xSymbolTableRoot;
/* #define xNotDefPId              ERROR__Cannot_use_output_without_TO */
#define xNotDefPId SDL_NULL

#define xDef_SDL_PId(V)       *(V) = SDL_NULL
#define yDef_SDL_PId(V)       xDef_SDL_PId(V)
#define yAssF_SDL_PId(V,E,A)  V = E
#define yEqF_SDL_PId(E1,E2)   xEq_SDL_PId(E1,E2)
#define yNEqF_SDL_PId(E1,E2)  (! xEq_SDL_PId(E1,E2))

/* 3.1 RST */
extern XCONST struct xIdStruct        xSymbolTableIdRec;
extern XCONST struct xPrsIdStruct yEnvR_env;
extern xIdNode yEnvO_env[];
/* 3.1 end */

/*---+--------------------------------------------------------------
     Instance number check (fab)
     Function which counts active instances given a symtab  node
-------------------------------------------------------------------*/

#ifdef X_INSTANCE_CHECK
#ifdef XOPTSIGNALALLOC
#define RELEASE_SIG(S) xReleaseSignal (S)
#else
#define RELEASE_SIG(S) xFree (S)
#endif

int GetActiveInstances (xPrsIdNode Node);
#define CHECK_INSTANCE_LIMIT1(IDNODE) \
if (GetActiveInstances (IDNODE) < IDNODE->MaxNoOfInst || IDNODE->MaxNoOfInst < 0) {
#define CHECK_INSTANCE_LIMIT2(IDNODE) \
} else { /* instance limit reached, creation impossible */ \
  RELEASE_SIG(&yOutputSignalPtr); /* free the startup signal */ \
  yVarP->Offspring = SDL_NULL; /* NULL offspring is set */ \
  printf ("Creation error\n"); \
}
#else
#define CHECK_INSTANCE_LIMIT1(IDNODE) 
#define CHECK_INSTANCE_LIMIT2(IDNODE)
#endif

/*
** for testenvironment
*/
#ifdef XMK_RITS

  #ifdef XMK_USE_SDL_SYSTEM_STOP
    #define XMK_RITS_TEST_OK  \
       xmk_RITS_result = 2;
    #define XMK_RITS_TEST_NOK \
       xmk_RITS_result = 3;
  #else
    #define XMK_RITS_TEST_OK  \
       exit (2);
    #define XMK_RITS_TEST_NOK \
       exit (3);
  #endif

  #define XMK_RITSPRINT(a)
  #define XMK_RITSPRINT1(a,b)
  #define XMK_RITSPRINT2(a,b,c)
  #define XMK_RITSPRINT3(a,b,c,d)
 
/*  xmk_T_ERR_INF experr;*/
  extern int xmk_RITS_result;
#endif

#endif /* _scttypes_h */
