/*************************************************************
Generated for IBM Rational SDL & TTCN Suite 6.3.0.3.23566 at Sat Nov 17 11:52:46 AM CET 2012
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 1990, 2012.  All Rights Reserved.

U.S. Government Users Restricted Rights:  
Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#include "cucf.h"
#include "er/ber/ber_content.h"

#ifndef CODER_REMOVE_BER

/*************************************************/
/******************* ENCODE **********************/
/*************************************************/

/**************************************************
 * NAME: BEREncode
 *       
 *
 */

int
BEREncode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;

      EPInit(Coder, Type);
      VMSInit(Coder, Type, Val);
      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = Coder->ER.MemEnd - 1;
      if (!(Coder->ER.Rule & er_BER))
        Coder->ER.Rule = (er_BER | CUCF_BER_LENGTH);

      BEREncVal(Coder, Type, Val, tk_Explicit);

      Length = Coder->ER.MemEnd - (Coder->ER.DataCurr + 1);
      memmove(Coder->ER.DataEnd, Coder->ER.DataCurr + 1, Length);
      BufSetDataEnd(Coder, Length, 7);
      Coder->ER.ValueBitLength = Length << 3;
    }

  Coder->EMS.IsAssigned = 0;
  return Coder->EMS.ErrorCode;
}

#endif /* !CODER_REMOVE_BER */
